
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tabledcsw.h"

#define TRUE  1
#define FALSE 0

                   // maximo de lineas (casos)
 #define MAXLIN 50000
// #define MAXLIN 10000
// #define MAXLIN 200000
                   // maximo de columnas (variables)
// #define MAXCOL 300
#define MAXCOL 10000
// #define MAXCOL 800
                   // tamanyo maximo de los nombres
#define MAXTNOM 80


void creaM2 (int nlt, int nc)
{
   int l;
   b    = (int **)  malloc (nlt * sizeof(int *));
   masc = (int **)  malloc (nlt * sizeof(int *));
   v    = (char **) malloc (nlt * sizeof(char *));
   for(l=0;l<nlt;l++){
      b[l]= (int *) malloc (nc * sizeof(int)) ;
      masc[l]= (int *) malloc (nc * sizeof(int)) ;
      v[l]= (char *) malloc (MAXTNOM * sizeof(char)) ;
      }
   f   = (int *)   malloc (nlt * sizeof(int)) ;
   tmn = (int *)   malloc (nc * sizeof(int)) ;
   tmx = (int *)   malloc (nc * sizeof(int)) ;
   cnc = (float *) malloc (nc * sizeof(float));
//  masc  = (int *) malloc (nc * sizeof(int)) ;
//  masc2 = (int *) malloc (nc * sizeof(int)) ;  // no hace falta
}

void umbrales ()
{
   int c, l;
   for (c=0; c<nc; c++){
      tmn[c] = b[0][c];
      tmx[c] = b[0][c];
      }
   for (c=0; c<nc; c++)
   for (l=0; l<nlt; l++){
      if (b[l][c] > tmx[c])
         tmx[c] = b[l][c];
      if (b[l][c] < tmn[c])
         tmn[c] = b[l][c];
      }
}

void acerosCnc (int n)
{
   int i;
   for (i=0; i<n; i++)
      cnc [i] = 0.0;
}

void escribeCnc (int n, char *fmt)
{
   int i;
   for (i=0; i<n; i++)
      printf (fmt, cnc [i]) ;
   printf ("\n");
}

void leeLaTabla ()
{
   int l, c;
   int ncleidos;
   ncleidos = scanf ("%d %d", &nc, &nlt);
   if (ncleidos == 0) {
      printf ("dcsw: error en leeTabla leyendo el tamao\n");
      exit (1);
      }
   if (nc > MAXCOL) {
      printf ("dcsw: error, numero de columnas %6d mayor que MAXCOL %6d\n", nc, MAXCOL);
      exit (1);
      }
   if (nlt > MAXLIN) {
      printf ("dcsw: error, numero de lineas %6d mayor que MAXLIN %6d\n", nlt, MAXLIN);
      exit (1);
      }
   creaM2 (nlt, nc);
   for(l=0; l<nlt; l++) {
      ncleidos = scanf ("%s", v[l]) ;
      if (ncleidos == 0) {
         printf ("dcsw: error en leeTabla leyendo caracter en linea %6d\n", l);
         exit (1);
         }
      for (c=0; c<nc; c++){
         ncleidos = scanf ("%d", &b[l][c]) ;
         if (ncleidos == 0) {
            printf ("dcsw: error en leeTabla leyendo numero %5d en linea %6d, caracter %s\n", c, l, v[l]);
            exit (1);
            }
         }
      }
   umbrales ();
   acerosCnc (nc);
}

void abre2LaTabla (char *nf, int mxlin, int nca, FILE **fl, int *nl1, int *nc1)
{
   FILE *f1;
   int ncleidos;
   f1 = fopen (nf, "r");
   if (f1 == NULL){
     printf ("dcsw: error en leeTabla abriendo %s\n", nf);
     exit (1);
     }
   ncleidos = fscanf (f1, "%d %d", nc1, nl1);
   if (ncleidos == 0) {
      printf ("dcsw: error en %s, en leeTabla leyendo el tamao\n", nf);
      exit (1);
      }
   if (*nc1 > MAXCOL) {
      printf ("dcsw: error en %s, numero de columnas %6d mayor que MAXCOL %6d\n",
               nf, *nc1, MAXCOL);
      exit (1);
      }
   if ((nca != 0) && (*nc1 != nca)) {
      printf ("dcsw: error en %s, numero de columnas %6d distinoto que antes %6d\n",
               nf, *nc1, nca);
      exit (1);
      }
   if (*nl1 > MAXLIN) {
      printf ("dcsw: error, %s numero de lineas %6d mayor que MAXLIN %6d\n",
               nf, *nl1, MAXLIN);
      exit (1);
      }
   if ((mxlin != 0) && (*nl1 > mxlin)) {
      printf ("dcsw: error, %s numero de lineas %6d mayor que mxlin %6d\n",
               nf, *nl1, mxlin);
      exit (1);
      }
   *fl = f1;
}

void lee2LatablaDts (FILE *fl, int nl0, int nlp)
{
   int l, c;
   int ncleidos;
   for(l=nl0; l < nl0+nlp; l++) {
      ncleidos = fscanf (fl, "%s", v[l]) ;
      if (ncleidos == 0) {
         printf ("dcsw: error en leeTabla leyendo caracter en linea %6d\n", l);
         exit (1);
         }
      for (c=0; c<nc; c++){
         ncleidos = fscanf (fl, "%d", &b[l][c]) ;
         if (ncleidos == 0) {
            printf ("dcsw: error en leeTabla leyendo numero %5d en linea %6d\n", c, l);
            exit (1);
            }
         }
      }
}

void lee2LaTabla (char *nf1, char *nf2)
{
   FILE *f1, *f2;
   int l1, c1, l2, c2;
   int mxlin;
   abre2LaTabla (nf1,  0,     0, &f1, &l1, &c1);
   mxlin = MAXLIN - l1;
   abre2LaTabla (nf2, mxlin, c1, &f2, &l2, &c2);
   nlt = l1+l2;
   nc = c1;
   creaM2 (nlt, nc);
   lee2LatablaDts (f1,  0, l1);
   lee2LatablaDts (f2, l1, l2);
   fclose (f1); fclose (f2);
   umbrales ();
   acerosCnc (nc);
}

void fijaFunc (char * nom)
{
   int l;
   for(l=0; l<nlt; l++){
      f[l] = (strcmp(v[l],nom) == 0);
      }
}

void oFunc (char * nom2)
{
   int l;
   for(l=0; l<nlt; l++){
      if (strcmp(v[l],nom2) == 0)
         f[l] = (TRUE == TRUE);
      }
}

int parteMayorIgual (int *f, int *g, int **b, int **c, int **m, int **n,
                               int nlt, int clo, int nvo)
{
   int l, ll;
   ll=0;
   for (l=0; l<nlt; l++)
      if (b[l][clo] >= nvo){
         c[ll] = b[l];
         g[ll] = f[l];
         n[ll] = m[l];
         ll ++;
         }
   return ll;
}

int parteMenor      (int *f, int *g, int **b, int **c, int **m, int **n,
                               int nlt, int clo, int nvo)
{
   int l, ll;
   ll=0;
   for (l=0; l<nlt; l++)
      if (b[l][clo] < nvo){
         c[ll] = b[l];
         g[ll] = f[l];
         n[ll] = m[l];
         ll ++;
         }
   return ll;
}

void cuentaColNiv (int *f, int **b, int nlt,
                            int col, int niv,
                            int *c00, int *c01, int *c10,  int *c11)
{
   register int l;
   int k00, k01, k10, k11;
   k00=k01=k10=k11=0 ;
   for(l=0; l<nlt; l++)
      if (b[l][col] < niv)
         if (f[l]) k01++;
         else      k00++;
      else
         if (f[l]) k11++;
         else      k10++;
   *c00 = k00; *c01 = k01; *c10 = k10; *c11 = k11;
}

void cuentaColNiveles (int *f, int **b, int nlt,
                                  int col,
                                  int *cv0, int *cv1)
{
   int l;
   int n;
   for (n=tmn[col]; n<=tmx[col]; n++) {
      cv0 [n] = 0;
      cv1 [n] = 0;
      }
   for(l=0; l<nlt; l++)
      if (f[l]) cv1 [ b[l][col] ] ++ ;
      else      cv0 [ b[l][col] ] ++ ;
}

void borraMascara ()
{
   int c;
   int l;
   for (c=0; c<nc; c++) 
   for (l=0; l<nlt; l++) {
      masc [l][c] = 0;
//    masc2 [l][c] = 0;
      }
} 

void actualizaMascara ()
{
/*
   int c;
   int l;
   for (c=0; c<nc; c++) 
   for (l=0; l<nlt; l++) {
      masc [l][c] = masc2 [l][c] ;
      }
*/
} 

int sinMascara (int ** masc, int nlt, int c)
{
   int l;
   for (l=0; l<nlt; l++)
      if (masc[l][c] == 1)
         return FALSE;
   return TRUE;
}

int numMascara (int ** masc, int nlt, int c)
{
   int l;
   int num;
   num = 0;
   for (l=0; l<nlt; l++)
      if (masc[l][c] == 1)
         num ++;
   return num;
}

void ponMascara (int ** masc, int nlt, int c)
{
   int l;
   for (l=0; l<nlt; l++)
      masc [l][c] = 1;
}
