
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "asocia.h"
#include "base.h"
#include "errors.h"

void leeT1 (char * dir, char * nf, char *** pt0, int * pnl)
{
  FILE * fd;
  char nfl[128];
  char b0[128];
  int i;
  int nc;
  int nl;
  char **t0;
  sprintf(nfl, "%s/%s", dir, nf);
  fd = fopen (nfl, "r");
  compruebaFd (fd, nf, "asocia.leeT1");
  fscanf (fd, "%d", & nl);
  t0 = (char **) malloc (nl * sizeof(char *));
  for (i=0; i<nl; i++) {
    fscanf(fd, "%s ", b0);
    nc = strlen (b0);
    t0 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t0 [i], b0);
    }
  fclose (fd);
  *pnl = nl;
  *pt0  = t0;
}

void leeT2 (char * dir, char * nf, char *** pt0, char *** pt1, int * pnl)
{
  FILE * fd;
  char nfl[128];
  char b0[128], b1[128];
  int i;
  int nc;
  int nl;
  char **t0, **t1;
  sprintf(nfl, "%s/%s", dir, nf);
  fd = fopen (nfl, "r");
  compruebaFd (fd, nf, "asocia.leeT2");
  fscanf (fd, "%d", & nl);
  t0 = (char **) malloc (nl * sizeof(char *));
  t1 = (char **) malloc (nl * sizeof(char *));
  for (i=0; i<nl; i++) {
    fscanf(fd, "%s %s ", b0, b1);
    nc = strlen (b0);
    t0 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t0 [i], b0);
    nc = strlen (b1);
    t1 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t1 [i], b1);
    }
  fclose (fd);
  *pnl = nl;
  *pt0  = t0;
  *pt1  = t1;
}

void leeT3 (char * dir, char * nf, char *** pt0, char *** pt1, char *** pt2, int * pnl)
{
  FILE * fd;
  char nfl[128];
  char b0[128], b1[128], b2[128];
  int i;
  int nc;
  int nl;
  char **t0, **t1, **t2;
  sprintf(nfl, "%s/%s", dir, nf);
  fd = fopen (nfl, "r");
  compruebaFd (fd, nf, "asocia.leeT3");
  fscanf (fd, "%d", & nl);
  t0 = (char **) malloc (nl * sizeof(char *));
  t1 = (char **) malloc (nl * sizeof(char *));
  t2 = (char **) malloc (nl * sizeof(char *));
  for (i=0; i<nl; i++) {
    fscanf(fd, "%s %s %s ", b0, b1, b2);
    nc = strlen (b0);
    t0 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t0 [i], b0);
    nc = strlen (b1);
    t1 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t1 [i], b1);
    nc = strlen (b2);
    t2 [i] = (char *) malloc ((nc+1) * sizeof(char));
    strcpy (t2 [i], b2);
    }
  fclose (fd);
  *pnl = nl;
  *pt0  = t0;
  *pt1  = t1;
  *pt2  = t2;
}

//         nm0 entrada
int asocT1 (char * nm0, char ** t0, int nl)
{
  int n0, n1, n2;
  int encontrado;
  int res;
  n0 = 0;
  n2 = nl - 1;
  if (strcmp(t0[n0], nm0)==0) {
    return TRUE;
    }
  if (strcmp(t0[n2], nm0)==0) {
    return TRUE;
    }
  n1 = (n0 + n2) / 2;
  encontrado = FALSE;
  for (; ((n2 - n0)>1) && ! encontrado; n1=(n0+n2)/2) {
    res = strcmp(t0[n1], nm0);
    if (res < 0) n0 = n1;
    if (res > 0) n2 = n1;
    if (res == 0) encontrado = TRUE;
    }
  return encontrado ;
}

//         nm0 entrada, nm1 salida
int asocT2 (char * nm0, char * nm1, char ** t0, char ** t1, int nl)
{
  int n0, n1, n2;
  int encontrado;
  int res;
  n0 = 0;
  n2 = nl - 1;
  if (strcmp(t0[n0], nm0)==0) {
    strcpy (nm1, t1[n0]);
    return TRUE;
    }
  if (strcmp(t0[n2], nm0)==0) {
    strcpy (nm1, t1[n2]);
    return TRUE;
    }
  n1 = (n0 + n2) / 2;
  encontrado = FALSE;
  for (; ((n2 - n0)>1) && ! encontrado; n1=(n0+n2)/2) {
    res = strcmp(t0[n1], nm0);
    if (res < 0) n0 = n1;
    if (res > 0) n2 = n1;
    if (res == 0) encontrado = TRUE;
    }
  if (encontrado)
    strcpy (nm1, t1[n1]);
  return encontrado ;
}

//         nm0 entrada, nm1 y nm2 salidas
int asocT3 (char * nm0, char * nm1, char * nm2, char ** t0, char ** t1, char ** t2, int nl)
{
  Boolean encontrado;
  encontrado =               asocT2 (nm0, nm1, t0, t1, nl);
  encontrado = encontrado && asocT2 (nm0, nm2, t0, t2, nl);
  return encontrado;
}
