
#include <stdio.h>
#include <stdlib.h>

#include "distrib2.h"

void nuevoVlim (int **nvlim, int *nn, int n1, int n2)
{
  int * vlim;
  int i, m, n;
  int j;
  // calulo de tamanio: n
  n = n1 + 1;
  i = 1;
  for (m=2; i*m <= n2*2; m *= 2)
    for (i=1; (i <= n1) && (i*m <= n2); i++)
      if (i*m > m/2 * n1){
        n++;
        // printf ("i: %6d\n", i*m);
        }
  // printf ("n: %3d\n", n);
  vlim = (int *) malloc (n * sizeof (int));
  // asignacion de valores limite
  for (j=0; j<=n1; j++)
    vlim [j] = j;
  i = 1;
  for (m=2; i*m <= n2*2; m *= 2)
    for (i=1; (i <= n1) && (i*m <= n2); i++)
      if (i*m > m/2 * n1){
        vlim [j] = i*m ;
        j++;
        }
  *nvlim = vlim;
  *nn    = n;
}

void imprimeVlim (int *vlim, int n)
{
  int j;
  for (j=0; j<n; j++)
    printf ("j: %3d vlim: %5d\n", j, vlim[j]);
}

//

tacumdist nuevoAcumDist (int n1, int n2)
{
  tacumdist acum;
  int i;
  acum = (tacumdist) malloc (sizeof(struct teacumdist));
  nuevoVlim (&(acum->vlim), &(acum->nl), n1, n2);
  acum->ac = (int *) malloc (acum->nl * sizeof(int));
  for (i=0; i<acum->nl; i++)
    acum->ac[i] = 0;
  return acum;
}

void anyadeaAcumDist (tacumdist acum, int val)
{
  int i0, i1, im;
  // buscar
  for (i0 = 0, i1 = acum->nl; (i1-i0) > 1; ){
    im = (i1+i0) / 2 ;
    if (acum->vlim[im] <= val)
      i0 = im;
    else
      i1 = im;
    }
  // anyadir
  acum->ac[i0] ++ ;
}

void imprimeAcumDist (tacumdist acum)
{
  int i;
  for (i=0; i<acum->nl; i++)
    printf ("%8d %6d\n", acum->vlim[i], acum->ac[i]);
}

//

tacumdist2 nuevoAcumDist2 (int n1, int n2)
{
  tacumdist2 acum2;
  int i;
  acum2 = (tacumdist2) malloc (sizeof(struct teacumdist2));
  nuevoVlim (&(acum2->vlim), &(acum2->nl), n1, n2);
  acum2->ac1 = (int *) malloc (acum2->nl * sizeof(int));
  acum2->ac2 = (int *) malloc (acum2->nl * sizeof(int));
  for (i=0; i<acum2->nl; i++) {
    acum2->ac1[i] = 0;
    acum2->ac2[i] = 0;
    }
  return acum2;
}

void anyadeaAcumDist2 (tacumdist2 acum2, int val, int iac)
{
  int i0, i1, im;
  // buscar
  for (i0 = 0, i1 = acum2->nl; (i1-i0) > 1; ){
    im = (i1+i0) / 2 ;
    if (acum2->vlim[im] <= val)
      i0 = im;
    else
      i1 = im;
    }
  // anyadir
  if (iac == 0)
    acum2->ac1[i0] ++ ;
  else
    acum2->ac2[i0] ++ ;
}

void imprimeAcumDist2 (tacumdist2 acum2)
{
  int i;
  for (i=0; i<acum2->nl; i++)
    printf ("%8d %6d %6d\n", acum2->vlim[i], acum2->ac1[i], acum2->ac2[i]);
}

//  nivel  menor que  acum2->vlim[i]
void imprimeAcumDist2falsosPond (tacumdist2 acum2, int kFalsPos)
{
  int * falsosPos, *falsosNeg;
  int i;
  falsosPos = (int *) malloc (acum2->nl * sizeof(int));
  falsosNeg = (int *) malloc (acum2->nl * sizeof(int));
  falsosPos[0] = 0;
  for (i=1; i<acum2->nl; i++)
    falsosPos[i] = falsosPos[i-1] + acum2->ac2[i] ;
  falsosNeg[acum2->nl-1] = acum2->ac1[acum2->nl-1] ;
  for (i=acum2->nl-2; i>=0; i--)
    falsosNeg[i] = falsosNeg[i+1] + acum2->ac1[i] ;
//
  printf("   dist.     ==     !=   S ==   S !=  k:%5d    %5d   %6d   %6d\n",
          kFalsPos, kFalsPos*3, kFalsPos*10, kFalsPos*30);
  for (i=0; i<acum2->nl; i++)
    printf ("%8d %6d %6d %6d %6d %8d %8d %8d %8d\n",
             acum2->vlim[i], acum2->ac1[i], acum2->ac2[i],
             falsosNeg [i], falsosPos[i],
             falsosNeg [i] + falsosPos[i] * kFalsPos,
             falsosNeg [i] + falsosPos[i] * kFalsPos * 3,
             falsosNeg [i] + falsosPos[i] * kFalsPos * 10,
             falsosNeg [i] + falsosPos[i] * kFalsPos * 30 );
}
