
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "atributos.h"
#include "base.h"
#include "convcar.h"
/*
*/
#include "errors.h"
#include "glifos.h"
#include "lista.h"
#include "imag.h"
#include "imagio.h"
#include "misc.h"
#include "opcns.h"
#include "pinta.h"
#include "tipos.h"

// temporal_tagnumpag
tglifo  glifcom_tagnumpag = 0L;
tglifo  gliffin_tagnumpag = 0L;
Boolean en_numpag = FALSE;

int nglifos = 0;

// -------------------- glifo --------------------

Boolean glifoCompuesto (tglifo glifo)
{
  /* depende de los tipos de glifo en glifo.h */
  return (glifo->tipo >= glifCompSec) &&
         (glifo->tipo <= glifCompTabla) ;

}

tglifo glifoNuevo ()
{
  tglifo nglifo;
  nglifo = (tglifo) malloc (sizeof(struct teglifo));
  nglifo->tipo        = glifNul ;
  nglifo->letras      = (char *) 0L;
  nglifo->propw       = (char *) 0L;
  nglifo->venDeGlifo  = (tvent) 0L;
  nglifo->ven2DeGlifo  = (tvent) 0L;
  nglifo->glifBase    = (tglifo) 0L;
  nglifo->listaGlifos = (tlistadglifo) 0L;
  nglifo->base        = -1;       /* valor impropio */
  nglifo->alturax     = -1;
  nglifo->lizq        = -1;
  nglifo->lder        = -1;
  nglifo->recon       = reconNulo;
  nglifo->recindc     = 0;
  nglifo->recparecc   = 0;
  nglifo->parteLogAnt = (tglifo) 0L;
  nglifo->parteLogSig = (tglifo) 0L;
  nglifo->ideglifo    = 0;
  nglifo->nid         = ++ nglifos;
  return nglifo;
}

tglifo duplicaGlifo (tglifo glifo)
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifo->tipo ;
  nglifo->letras     = strdup (glifo->letras);
  return nglifo;
}

tglifo glifoClinNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifClin ;
  return nglifo;
}

tglifo glifoBlanNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifBlan ;
  return nglifo;
}

tglifo glifoEspvNuevo ()
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifEspv ;
  return nglifo;
}

tglifo glifoLetNuevo (char *let)
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo       = glifCar ;
  nglifo->letras     = strdup (let);
  return nglifo;
}

void ponLetGlifo (tglifo glifo, char *let)
{
  free (glifo->letras);
  glifo->letras     = strdup (let);
}

void ponLetwGlifo (tglifo glifo, char *letw)
{
  free (glifo->propw);
  glifo->propw      = strdup (letw);
}

tglifo glifoCompNuevo (int tipGlif)
{
  tglifo nglifo;
  nglifo = glifoNuevo ();
  nglifo->tipo        =  tipGlif ;
  nglifo->listaGlifos =  listadglifoNueva ();
  return nglifo;
}

tglifo glifoCompSecNuevo ()
{
  return glifoCompNuevo (glifCompSec);
}

tglifo glifoCompPalNuevo ()
{
  return glifoCompNuevo (glifCompPal);
}

tglifo glifoCompLinNuevo ()
{
  return glifoCompNuevo (glifCompLin);
}

tglifo glifoCompClmpNuevo ()
{
  return glifoCompNuevo (glifCompClmp);
}

tglifo glifoCompPaginaNuevo ()
{
  return glifoCompNuevo (glifCompPagina);
}

tglifo glifoCompPliegoNuevo ()
{
  return glifoCompNuevo (glifCompPliego);
}

tglifo glifoCompTablaNuevo ()
{
  return glifoCompNuevo (glifCompTabla);
}

tglifo glifoDeArrayDeGlifos (tglifo *glifos, int n)
{
  tglifo nglifo;
  int i;
  nglifo = glifoCompNuevo (glifCompPliego);
  for (i=0; i<n; i++)
    aniadeGlifoafinlista (nglifo->listaGlifos, glifos[i]);
  return nglifo;
}

void ponpadreGlifo (tglifo glifop, tglifo glifoh)
{
  glifoh->glifBase = glifop ;
}

void casaGlifoVent (tglifo glifo, tvent vent)
{
  vent->GLifoDeVen  = glifo ;
  glifo->venDeGlifo = vent ;
}

int separacionHorizEntreGlifos (tglifo glifo1, tglifo glifo2)
{
  int separacion;
  tvent vent1, vent2;
  if ((glifo1 == 0) || (glifo2 == 0))
    return -1;
  vent1 = glifo1->venDeGlifo;
  vent2 = glifo2->venDeGlifo;
  separacion = vent2->dx - (vent1->dx + vent1->tx);
  // describeGlifo (glifo2,1);
  return separacion;
}


void adoptaGlifo (tglifo glifop, tglifo glifoh)
{
  glifoh->glifBase = glifop ;
  aniadeGlifoafinlista (glifop->listaGlifos, glifoh);
}

tnodolglifo nodolglifoDeGlifo (tglifo glifo)
{
  tnodolglifo nodolGlifo;
  if (glifo->glifBase == 0L)
    return 0L;
  if (glifo->glifBase->listaGlifos == 0L)
    return 0L;
  nodolGlifo = glifo->glifBase->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    if (nodolGlifo->aglifo == glifo)
      break;
    if ( nodolGlifo->siguiente == 0L)
      return 0L;
    nodolGlifo = nodolGlifo->siguiente;
    }
  return nodolGlifo;
}

tglifo glifoBasenTipo (tglifo glifo, int tipoGlifo)
{
  tglifo glifoBasen;
  glifoBasen = glifo;
  if (glifoBasen == 0L) {
    printf ("error: ocre.glifos.glifoBasenTipo\n");
    exit (1);
    }
  while (glifoBasen->tipo != tipoGlifo) {
    glifoBasen = glifoBasen->glifBase ;
    if (glifoBasen == 0L) {
      printf ("error: ocre.glifos.glifoBasenTipo\n");
      exit (1);
      }
    }
  return glifoBasen;
}

tglifo glifoSiguienteDeGlifo (tglifo glifo)
{
  tnodolglifo nodolGlifo;
  nodolGlifo = nodolglifoDeGlifo (glifo);
  if (nodolGlifo == 0L)
    return 0L;
  if (nodolGlifo->siguiente == 0L)
    return 0L;
  else
    return nodolGlifo->siguiente->aglifo ;
}

tglifo glifoAnteriorDeGlifo (tglifo glifo)
{
  tnodolglifo nodolGlifo;
  nodolGlifo = nodolglifoDeGlifo (glifo);
  if (nodolGlifo == 0L)
    return 0L;
  if (nodolGlifo->anterior == 0L)
    return 0L;
  else
    return nodolGlifo->anterior->aglifo ;
}

// -------------------- lista glifos --------------------

tnodolglifo nodolglifoNuevo (tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = (tnodolglifo) malloc (sizeof(struct tenodolglifo));
  nnodolGlifo->aglifo = glifo;
  nnodolGlifo->siguiente = (tnodolglifo) 0L;
  nnodolGlifo->anterior  = (tnodolglifo) 0L;
  return nnodolGlifo ;
}

tlistadglifo listadglifoNueva ()
{
  tlistadglifo nlistadglifo;
  nlistadglifo = (tlistadglifo) malloc (sizeof(struct telistadglifo));
  nlistadglifo->primero = (tnodolglifo) 0L;
  nlistadglifo->ultimo  = (tnodolglifo) 0L;
  return nlistadglifo ;
}

Boolean listadglifoVacia (tlistadglifo ldglifo)
{
  return ldglifo->primero == (tnodolglifo) 0L ;
}

void aniadeGlifoacomlista (tlistadglifo ldglifo, tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = nodolglifoNuevo (glifo);
  if (ldglifo->primero == (tnodolglifo) 0L) {
    ldglifo->primero = nnodolGlifo ;
    ldglifo->ultimo  = nnodolGlifo ;
    }
  else {
    nnodolGlifo->siguiente  = ldglifo ->primero ;
    ldglifo->primero->anterior = nnodolGlifo ;
    ldglifo->primero = nnodolGlifo ;
    }
}

void aniadeGlifoafinlista (tlistadglifo ldglifo, tglifo glifo)
{
  tnodolglifo nnodolGlifo;
  nnodolGlifo = nodolglifoNuevo (glifo);
  if (ldglifo->primero == (tnodolglifo) 0L) {
    ldglifo->primero = nnodolGlifo ;
    ldglifo->ultimo  = nnodolGlifo ;
    }
  else {
    nnodolGlifo->anterior  = ldglifo ->ultimo ;
    ldglifo->ultimo->siguiente = nnodolGlifo ;
    ldglifo ->ultimo = nnodolGlifo ;
    }
}

void aniadeGlifoalistaAntes (tlistadglifo ldglifo, tglifo glifo, tnodolglifo nodolGlifo)
{
  if (ldglifo->primero == nodolGlifo)
    aniadeGlifoacomlista (ldglifo, glifo);
  else {
    tnodolglifo nnodolGlifo;
    nnodolGlifo = nodolglifoNuevo (glifo);
    nnodolGlifo->siguiente = nodolGlifo ;
    nnodolGlifo->anterior  = nodolGlifo->anterior;
    nodolGlifo->anterior->siguiente = nnodolGlifo;
    nodolGlifo->anterior            = nnodolGlifo;
  }
}

void eliminaNGlifodelista (tlistadglifo ldglifo, tnodolglifo nodolGlifo)
{
  tnodolglifo nodoantes, nododespues;
  if (ldglifo->primero == nodolGlifo)
    if (ldglifo->ultimo == nodolGlifo) {
      ldglifo->primero = 0L;
      ldglifo->ultimo  = 0L;
      }
    else {
      ldglifo->primero = ldglifo->primero->siguiente;
      ldglifo->primero->anterior = 0L;
      }
  else
    if (ldglifo->ultimo == nodolGlifo) {
      ldglifo->ultimo = ldglifo->ultimo->anterior;
      ldglifo->ultimo->siguiente = 0L;
      }
    else {
      nodoantes   = nodolGlifo->anterior;
      nododespues = nodolGlifo->siguiente;
      nodoantes->siguiente  = nododespues;
      nododespues->anterior = nodoantes;
      }
}

int longListagl (tlistadglifo ldglifo)
{
  int i=0;
  tnodolglifo nodolglifo;
  for (nodolglifo = ldglifo->primero; nodolglifo != 0L;nodolglifo = nodolglifo->siguiente) {
    i++ ;
    }
    return  i ;
}

tnodolglifo enesimoNodoDeListaGlifos (tlistadglifo ldglifo, int n)
{
  int i=1;
  tnodolglifo nodolglifo;
  for (nodolglifo = ldglifo->primero; i == n; nodolglifo = nodolglifo->siguiente) {
    i++ ;
    }
    return  nodolglifo ;
}

int longListagimoNodoDeListaGlifos (tlistadglifo ldglifo)
{
  int i=0;
  tnodolglifo nodolglifo;
  for (nodolglifo = ldglifo->primero; nodolglifo != 0L;nodolglifo = nodolglifo->siguiente) {
    i++ ;
    }
    return  i ;
}

void substituye2glifospor1 (tnodolglifo nodolGlifo, tglifo glifoNuevo)
{
  tlistadglifo listaGlifos;
  listaGlifos = nodolGlifo->aglifo->glifBase->listaGlifos;
  aniadeGlifoalistaAntes (listaGlifos, glifoNuevo, nodolGlifo);
  eliminaNGlifodelista (listaGlifos, nodolGlifo->siguiente);
  eliminaNGlifodelista (listaGlifos, nodolGlifo);
}

tglifo glifoUnionConSiguiente (tnodolglifo nodolGlifo)
{
  tglifo glifoNuevo;
  tvent ventanaNueva;
  if (mismaBaseVentanas (nodolGlifo->aglifo->venDeGlifo,
                         nodolGlifo->siguiente->aglifo->venDeGlifo)) {
    unionGventanas ( &ventanaNueva, nodolGlifo->aglifo->venDeGlifo,
	                            nodolGlifo->siguiente->aglifo->venDeGlifo);
    glifoNuevo = glifoLetNuevo ("-?");
    casaGlifoVent (glifoNuevo, ventanaNueva);
    ponpadreGlifo (nodolGlifo->aglifo->glifBase, glifoNuevo);
    return glifoNuevo ;
    }
  else
    return (tglifo) 0L ;
}

Boolean enlazaLogGlifos (tglifo glif1, tglifo glif2)
{
  tglifo glifoBaseAnt, glifoBaseSig;
  if (glif1 == 0L) {
    if (glif2 == 0L)
      return FALSE;
    glifoBaseAnt = glifoAnteriorDeGlifo (glif1->glifBase);
    if (glifoBaseAnt == 0L)
      return FALSE;
    glif1 = glifoBaseAnt->listaGlifos->ultimo->aglifo;
    }
  if (glif2 == 0L) {
    glifoBaseSig = glifoSiguienteDeGlifo (glif1->glifBase);
    if ((glifoBaseSig == 0L) || !glifoCompuesto(glifoBaseSig))
      return FALSE;
    glif2 = glifoBaseSig->listaGlifos->primero->aglifo;
    }
  glif1->parteLogSig = glif2;
  glif2->parteLogAnt = glif1;
  return TRUE;
}

tglifo seleccionaSubglifo (tglifo glifo, char *selec)
{
  int lsel;
  tglifo g;
  int i, j;
  lsel = strlen (selec);
  if (lsel < 2) {
    printf ("ocre.glifos.seleccionaSubglifo: error, seleccion corta\n");
    exit (41);
    }
  if (selec[0] != 'c') {
    printf ("ocre.glifos.seleccionaSubglifo: seleccion no comienza por 'c'\n");
    exit (41);
    }
  i = lsel - 1;
  if (selec[i] != 'r') {
    printf ("ocre.glifos.seleccionaSubglifo: seleccion no acaba en 'r'\n");
    exit (41);
    }
  i -- ;
  g = glifo;
  while (i>0) {
    j = 1;
    while (selec[i]=='d'){
      i--; j++;
      }
    if (selec[i] != 'a') {
      printf ("ocre.glifos.seleccionaSubglifo: seleccion le falta una 'a'\n");
      exit (41);
      }
    if (listadglifoVacia (g->listaGlifos)) {
      printf ("ocre.glifos.seleccionaSubglifo:  no hay subglifos\n");
      exit (41);
      }
    if (longListagl (g->listaGlifos) < j) {
      printf ("ocre.glifos.seleccionaSubglifo:  no hay %3d tantos subglifos\n", j);
      exit (41);
      }
    g = enesimoNodoDeListaGlifos (g->listaGlifos, j) -> aglifo;
    i--;
    }
 return g;
}


// -------------------- trazas --------------------

static char * nombreTipoGlifo[] = {
  "glifCar", "glifBlan", "glifClin", "glifEspv", "glifNul", "glifArtf", "glifSecuen",
  "glifCompSec", "glifCompPal", "glifCompLin", "glifCompClmp",
  "glifCompPagina", "glifCompPliego", "glifCompTabla",
  "#"
};
static char * nombreTipoReconocimiento[] = {
  "reconNulo",
  "reconComp", "reconDcswft", "reconDcswftw",
  "reconPreg", "reconMisc", "reconDicc",
  "#"
};

void describeGlifo (tglifo glifo, int niv)
{
  tnodolglifo nodolGlifo;
  tlistadglifo lisgli;
  printf ("g%d tipo: %s", niv, nombreTipoGlifo[glifo->tipo]);
  lisgli = glifo->listaGlifos ; 
  printf ("  ideglifo: %4d", glifo->ideglifo);
  if (glifo->recon != 0){
    printf ("  reconocim: %s", nombreTipoReconocimiento[glifo->recon]);
    if (glifo->letras != 0L)
      printf (" letras: %s", glifo->letras);
    if (glifo->propw != 0L)
      printf (" propw: %s", glifo->propw);
    }
  if (lisgli != 0L)
    printf ("  %3d - %3d subglifos\n", niv, longListagl(glifo->listaGlifos));
  else
    printf ("\n");
  if (glifo->venDeGlifo == 0L)
    printf ("g%d sin ventana asociada\n", niv);
  else {
    printf ("g%d ventana asociada:\n", niv);
    describeVentana (glifo->venDeGlifo);
    }
  printf (" base: %4d, alturax: %4d\n", glifo->base, glifo->alturax);
  if ((niv > 0) && (lisgli != 0L))
    for (nodolGlifo = lisgli->primero; nodolGlifo != 0L; nodolGlifo= nodolGlifo->siguiente)
      describeGlifo (nodolGlifo->aglifo, niv-1);
}

// sin probar
void enmarcaRGlifo (tglifo glifo, int niv, int nivac)
{
  tnodolglifo nodolGlifo;
  tlistadglifo lisgli;
  lisgli = glifo->listaGlifos ; 
  if (glifo->venDeGlifo != 0L) {
    printf ("enmarcaVentana (glifo->venDeGlifo);  niv %d\n", niv);
    pintaRectIntVent (glifo->venDeGlifo);
    }
  if ((niv > 0) && (lisgli != 0L))
    for (nodolGlifo = lisgli->primero; nodolGlifo != 0L; nodolGlifo= nodolGlifo->siguiente)
      enmarcaRGlifo (nodolGlifo->aglifo, niv-1, nivac);
}

// sin probar
void aficheroRGlifo (tglifo glifo, int niv, char* fnom)
{
  int localt = 0;
  tnodolglifo nodolGlifo;
  tlistadglifo lisgli;
  int ig;
  char fnom_ig[128];
  ig = 1;
  lisgli = glifo->listaGlifos ; 
  if (glifo->venDeGlifo != 0L) {
            if (localt) printf ("xxxxx (glifo->venDeGlifo);  niv %d, nf: %s\n", niv, fnom);
    escribeVentana (glifo->venDeGlifo, fnom);
    }
  if ((niv > 0) && (lisgli != 0L))
    for (nodolGlifo = lisgli->primero; nodolGlifo != 0L; nodolGlifo= nodolGlifo->siguiente) {
      sprintf (fnom_ig, "%s_%d", fnom, ig);
      aficheroRGlifo (nodolGlifo->aglifo, niv-1, fnom_ig);
      ig++;
      }
}

// -------------------- aplica recursivam. --------------------

// aplica recursivamente a un glifo de un tipo una funcion con unos datos
void aplicaGtRFncD (tglifo glifo, int tipo, void fn(tglifo, tpgen), tpgen datos)
{
  tnodolglifo nodolGlifo;
  if (glifo->tipo == tipo)
    fn (glifo, datos);
  else
    if (glifoCompuesto(glifo))
      for (nodolGlifo = glifo->listaGlifos->primero;
           nodolGlifo !=  0L;
           nodolGlifo = nodolGlifo->siguiente) {
        aplicaGtRFncD (nodolGlifo->aglifo, tipo, fn, datos);
        }
}

// aplica recursivamente a un glifo de un tipo una funcion (sin datos)
void aplicaGtRFn (tglifo glifo, int tipo, void fn(tglifo))
{
  tnodolglifo nodolGlifo;
  if (glifo->tipo == tipo)
    fn (glifo);
  else
    if (glifoCompuesto(glifo))
      for (nodolGlifo = glifo->listaGlifos->primero;
           nodolGlifo !=  0L;
           nodolGlifo = nodolGlifo->siguiente) {
        aplicaGtRFn (nodolGlifo->aglifo, tipo, fn);
        }
}

// ----------

void cuentaTiposenGlifoR0 (int *cntglifo, tglifo glifo)
{
  tnodolglifo nodolGlifo;
  cntglifo[glifo->tipo]++ ;
  if (glifoCompuesto(glifo))
    for (nodolGlifo = glifo->listaGlifos->primero;
         nodolGlifo !=  0L;
         nodolGlifo = nodolGlifo->siguiente) {
      cuentaTiposenGlifoR0 (cntglifo, nodolGlifo->aglifo);
      }
}

void cuentaTiposenGlifo (int **ncntglifo, tglifo glifo)
{
  int * cntglifo;
  int tg;
  cntglifo = (int *) malloc (glifZz * sizeof (int)); 
  for (tg = glifCar; tg <= glifZz; tg++)
    cntglifo [tg] = 0;
  cuentaTiposenGlifoR0 (cntglifo, glifo);
  *ncntglifo = cntglifo;
}

void imprimeRecuentoTiposenGlifo (int *cntglifo)
{
  int tg;
  for (tg = glifCar; tg < glifZz; tg++)
    printf ("%5d %s\n", cntglifo[tg], nombreTipoGlifo[tg]);
}

// ----------

void incrementaCnrecon (tglifo glifo, tpgen datos)
{
  int *cnrecon = (int *) datos;
  cnrecon[glifo->recon] ++ ;
}

void cuentaTiposReconocimientos (int **ncnrecon, tglifo glifo)
{
  int * cnrecon;
  int tr;
  cnrecon = (int *) malloc ((reconZz+1) * sizeof (int)); 
  // printf ("cuentaTiposReconocimientos\n");
  for (tr = reconNulo; tr <= reconZz; tr++)
    cnrecon [tr] = 0;
  aplicaGtRFncD (glifo, glifCar, incrementaCnrecon, cnrecon);
  *ncnrecon = cnrecon;
}

void imprimeRecuentoReconocimientos (int *cnrecon)
{
  int tr;
  for (tr = glifCar; tr < reconZz; tr++)
    printf ("%5d %s\n", cnrecon[tr], nombreTipoReconocimiento[tr]);
}

// ----------

void incrementaCnreconDcsw (tglifo glifo, tpgen datos)
{
  int *cnrecon = (int *) datos;
  if (glifo->recon == reconDcswft) 
    cnrecon[glifo->recindc] ++ ;
}

void cuentaTiposReconocimientosDcsw (int **ncnreconDcsw, tglifo glifo)
{
  int * cnreconDcsw;
  int i;
  cnreconDcsw = (int *) malloc (11 * sizeof (int));   // cambiar con mas arboles
  // printf ("cuentaTiposReconocimientosDcsw\n");
  for (i = 0; i <= 10; i++)
    cnreconDcsw [i] = 0;
  aplicaGtRFncD (glifo, glifCar, incrementaCnreconDcsw, cnreconDcsw);
  *ncnreconDcsw = cnreconDcsw;
}

void imprimeRecuentoReconocimientosDcsw (int *cnreconDcsw)
{
  int i;
  for (i = 0; i <= 10; i++)
    if (cnreconDcsw[i] != 0)
      printf ("%5d %2d\n", cnreconDcsw[i], i);
}

void imprimeTasaReconocimientosDcsw (int *cnreconDcsw, int *cntglifo)
{
  double tasa;
  int i;
  int k;
  int mx;
  k = 0;
  mx = 1;
  for (i = 0; i <= 10; i++) {
    k += cnreconDcsw[i] * i;
   if ( (i > mx) && (cnreconDcsw[i] > 0) )
      mx = i;
    }
  tasa = (k * 100.0) / (cntglifo[glifCar] * mx);
  printf ("tasa: %7.3f\n\n", tasa);
}

// ----------

int nmaxcompc = 50;     // cambiar si no es suficiente (ROLLO)

void incrementaCnreconComp (tglifo glifo, tpgen datos)
{
  int *cnrecon = (int *) datos;
  if (glifo->recon == reconComp) 
    cnrecon[glifo->recparecc] ++ ;
}

void cuentaTiposReconocimientosComp (int **ncnreconComp, tglifo glifo)
{
  int * cnreconComp;
  int i;
  cnreconComp = (int *) malloc (nmaxcompc * sizeof (int));
  // printf ("cuentaTiposReconocimientosComp\n");
  for (i = 0; i <= nmaxcompc; i++)
    cnreconComp [i] = 0;
  aplicaGtRFncD (glifo, glifCar, incrementaCnreconComp, cnreconComp);
  *ncnreconComp = cnreconComp;
}

void imprimeRecuentoReconocimientosComp (int *cnreconComp)
{
  int i;
  for (i = 0; i <= nmaxcompc; i++)
    if (cnreconComp[i] != 0)
      printf ("%5d %2d\n", cnreconComp[i], i);
}

void imprimeTasaReconocimientosComp (int *cnreconComp, int *cntglifo)
{
  double tasa;
  int i;
  int k;
  k = 0;
  for (i = 0; i <= nmaxcompc; i++)
    k += cnreconComp[i] * i;
  tasa = (k * 100.0) / (cntglifo[glifCar] * 5);
  printf ("tasa: %7.3f\n\n", tasa);
}

// -------------------- escribe palabras ..  --------------------

void escribePalabrasdeGlifosenListaR0 (tlistadglifo ldglifo)
{
  int localt = 0;
  tnodolglifo nodolGlifo;
  char carsus[1024];
  if (ldglifo == 0L) {
            if (localt) {printf ("glifos.escribePalabrasdeGlifosenListaR0 error:\n");
                         exit (1); }
    return ;
    }
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCompSec :
        escribePalabrasdeGlifosenListaR0 (nodolGlifo->aglifo->listaGlifos);
        break ;
      case glifCar :
	ssalidaDeUtf (carsus, nodolGlifo->aglifo->letras);
        printf ("%s", carsus);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
}

void escribePalabradeGlifo (tpgen glifo)
{
  escribePalabrasdeGlifosenListaR0( ((tglifo)glifo)->listaGlifos );
  printf ("\n");
}

void escribePalabradeGlifoL (tpgen glifo)
{
  tglifo gli = (tglifo) glifo;
  escribePalabrasdeGlifosenListaR0(gli->listaGlifos );
  if (gli->parteLogSig != 0L)
    escribePalabrasdeGlifosenListaR0(gli->parteLogSig->listaGlifos );
  printf ("\n");
}

void escribePalabradeGlifoyPares (tpgen glifo)
{
  printf ("_ %2d ", parejasDeLetrasEnPalabra(glifo));
  escribePalabrasdeGlifosenListaR0( ((tglifo)glifo)->listaGlifos );
  printf ("\n");
}

void escribePalabrasdeGlifosenListaR (tlistadglifo ldglifo, int *n, Boolean log)
{
  tnodolglifo nodolGlifo;
  tglifo glifo;
  int np;
  char carsus[1024];
  np = *n;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    glifo = nodolGlifo->aglifo ;
    switch (glifo->tipo) {
      case glifCompSec :
        escribePalabrasdeGlifosenListaR (glifo->listaGlifos, &np, log);
        break ;
      case glifCar :
	ssalidaDeUtf (carsus, glifo->letras);
        printf ("%s", carsus);
        break ;
      case glifClin :
        if (!log) {
          printf ("\n");
	  }
        break ;
      case glifBlan :
      case glifEspv :
        break ;
      case glifCompPliego :
      case glifCompPagina :
      case glifCompClmp :
      case glifCompLin :
        escribePalabrasdeGlifosenListaR (glifo->listaGlifos, &np, log);
        break ;
      case glifCompPal :
        np++ ;
        if (log) {
	  if (glifo->parteLogAnt == 0L ) {
            printf ("\n");
	    escribePalabrasdeGlifosenListaR (glifo->listaGlifos, &np, log);
	    }
	  if (glifo->parteLogSig != 0L ) {
	    escribePalabrasdeGlifosenListaR (glifo->parteLogSig->listaGlifos, &np, log);
	    }
          }
	else {
          printf ("\n");
          printf ("%4d ", np);
	  {
	  /*
	  int i;
	  for (i=0; i<6; i++)
            printf ("%3d ",glifo->venDeGlifo->caracIncl[i]);
	    */
	  }
	  printf ("%3d ",glifo->venDeGlifo->incl);
	  printf ("_ %2d ", parejasDeLetrasEnPalabra(glifo));
	  escribePalabrasdeGlifosenListaR (glifo->listaGlifos, &np, log);
	  }
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  *n = np;
}

void escribePalabrasdeGlifosenLista (tlistadglifo ldglifo)
{
  int np;
  np = 0;
  printf ("\n%5d ", np);
  escribePalabrasdeGlifosenListaR (ldglifo, &np, FALSE);
  printf ("\n");
}

void escribePalabrasLogdeGlifosenLista (tlistadglifo ldglifo)
{
  int np;
  np = 0;
  escribePalabrasdeGlifosenListaR (ldglifo, &np, TRUE);
  printf ("\n");
}

// -------------------- escribe letras ..  --------------------

void escribeGlifoBlanco (tglifo glifo)
{
  int sep;
  tglifo glifoAnt, glifoSig;
  glifoAnt = glifoAnteriorDeGlifo (glifo);
  glifoSig = glifoSiguienteDeGlifo (glifo);
  //
  if ((glifoAnt->tipo) == glifCompPal)
    glifoAnt = glifoAnt->listaGlifos->ultimo->aglifo;
  if ((glifoSig->tipo) == glifCompPal)
    glifoSig = glifoSig->listaGlifos->primero->aglifo;
  //
  sep = separacionHorizEntreGlifos (glifoAnt, glifoSig);
  if (sep < 16)
    printf ("%s","");
  else if (sep < 30)
    printf (" ");
  else
    printf ("   ");
}

void escribeLetrasdeGlifosenListaR (tlistadglifo ldglifo, int *n);

void escribeLetrasdeGlifos (tglifo glifo, int *n)
{
  int nc;
  char carsus[1024];
  nc = *n;
  switch (glifo->tipo) {
    case glifCar :
//      printf (" %4d %4d ", glifo->venDeGlifo->dx,
//                glifo->venDeGlifo->dx+glifo->venDeGlifo->tx-1);
      if (u_opcion)
	strcpy (carsus, glifo->letras);
      else
	ssalidaDeUtf (carsus, glifo->letras);
      printf ("%s", carsus);
      // traza para falsos positivos, vie feb 22 12:08:44 CET 2013
      if (p_valori == 31) 
        if (carsus[0] == 'I') {
          printf ("=== === ===\n");
          describeGlifo (glifo, 1);
          }
      nc++ ;
      break ;
    case glifEspv :
    case glifClin :
      if (R_opcion) {
        printf ("\r");
	}
      printf ("\n");
      if (N_opcion) {
        printf ("%5d ", nc);
        }
      break ;
    case glifBlan :
      printf (" ");
      // escribeGlifoBlanco (glifo);
      break ;
    case glifCompLin :
	/* ====
	printf ("%6d\n", glifo->linAlinizq);
	*/
	if (glifo->linAlinizq >= 10)
	printf(" ");
    case glifCompPliego :
    case glifCompPagina :
    case glifCompClmp :
    case glifCompPal :
    case glifCompSec :
      escribeLetrasdeGlifosenListaR (glifo->listaGlifos, &nc);
      break ;
    }
  *n = nc;
}

void escribeLetrasdeGlifosenListaR (tlistadglifo ldglifo, int *n)
{
  tnodolglifo nodolGlifo;
  tglifo glifo;
  int nc;
  nc = *n;
  // if (nc == 575) tirarPrograma ();
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    glifo = nodolGlifo->aglifo;
    if (glifo == glifcom_tagnumpag) {  // temporal_tagnumpag (5 lin)
      en_numpag = TRUE;
      if (y_valori == 1)
          printf("<npag>");
      }
    escribeLetrasdeGlifos (glifo, &nc);
    if (glifo == gliffin_tagnumpag) { // temporal_tagnumpag (5 lin)
      en_numpag = FALSE;
      if (y_valori == 1)
        printf("</npag>");
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  *n = nc;
}

void escribeLetrasdeGlifosenLista (tlistadglifo ldglifo, int * nc)
{
  if (N_opcion) {
    printf ("%5d ", *nc);
    }
  escribeLetrasdeGlifosenListaR (ldglifo, nc);
  if (N_opcion) {
    if (R_opcion) {
      printf ("\r");
      }
    printf ("\n");
    }
}

void escribeEnFdLetrasdeGlifosenLista (FILE *fd, tlistadglifo ldglifo)
{
  char carsus[1024];
  tnodolglifo nodolGlifo;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
	ssalidaDeUtf (carsus, nodolGlifo->aglifo->letras);
        fprintf (fd, "%s", carsus);
        break ;
      case glifEspv :
      case glifClin :
        if (R_opcion) {
          fprintf (fd, "\r");
          }
        fprintf (fd, "\n");
        break ;
      case glifBlan :
        fprintf (fd, " ");
        break ;
      case glifCompPliego :
      case glifCompPagina :
      case glifCompClmp :
      case glifCompLin :
      case glifCompPal :
      case glifCompSec :
        escribeEnFdLetrasdeGlifosenLista (fd, nodolGlifo->aglifo->listaGlifos);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
}

void escribeEnBufLetrasdeGlifosenListaR (char *buf, tlistadglifo ldglifo)
{
  char carsus[1024];
  tnodolglifo nodolGlifo;
  nodolGlifo = ldglifo->primero;
  while (nodolGlifo !=  0L) {
    switch (nodolGlifo->aglifo->tipo) {
      case glifCar :
	ssalidaDeUtf (carsus, nodolGlifo->aglifo->letras);
        strcat (buf, carsus);
        // strcat (buf, nodolGlifo->aglifo->letras);
        break ;
      case glifEspv :
      case glifClin :
        if (R_opcion) {
          strcat (buf, "\r");
          }
        strcat (buf, "\n");
        break ;
      case glifBlan :
        strcat (buf, " ");
        break ;
      case glifCompPliego :
      case glifCompPagina :
      case glifCompClmp :
      case glifCompLin :
      case glifCompPal :
      case glifCompSec :
        escribeEnBufLetrasdeGlifosenListaR (buf, nodolGlifo->aglifo->listaGlifos);
        break ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
}

void escribeEnBufLetrasdeGlifosenLista (char *buf, tglifo glifo)
{
  // buf [0] = '0C';   // antes, en la llamada, asi acumula,
  escribeEnBufLetrasdeGlifosenListaR (buf, glifo->listaGlifos);
}

void escribeEnFnomLetrasdeGlifosenLista (char *nf, tlistadglifo ldglifo)
{
  FILE * fd;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "glifos.escribeEnFnomLetrasdeGlifosenLista");
  escribeEnFdLetrasdeGlifosenLista (fd, ldglifo);
  fclose (fd);
}

void ponNombreSim (char *nf, char *ndir, char *lc, int nc)
{
  char nomu[128];
  sustrDeUtf8 (nomu, lc);
  sprintf (nf, "%s/%06d-%s.pgm", ndir, nc, nomu);
}

void ponNombreSim2 (char *nf, char *ndir, char *apndir, char *lc, int nc)
{
  char nomu[128];
  // printf ("%s=%s=%06d=\n", ndir, apndir, nc);
  sustrDeUtf8 (nomu, lc);
  sprintf (nf, "%s%s/%06d-%s.pgm", ndir, apndir, nc, nomu);
  // printf ("%s\n", nf);
}

// -------------------- alin. base y altx  --------------------

void escribeEspacios (tglifo glifoLinea)
{
  tnodolglifo nodolGlifo;
  tglifo glifopal;
  int anchpauta;
  tvent ventpal;
  int x1, x0, anch, x1_ant;
  anchpauta = glifoLinea -> base - glifoLinea -> alturax ;
  for (nodolGlifo = glifoLinea->listaGlifos->primero;
       nodolGlifo !=  0L;
       nodolGlifo = nodolGlifo->siguiente) {
    glifopal = nodolGlifo->aglifo;
    if (glifopal->tipo == glifCompPal) {
      ventpal   = glifopal->venDeGlifo;
      x0 = ventpal -> dx ;
      anch = ventpal -> tx;
      x1 = x0 + anch - 1 ;
      printf (" %4d %4d %4d", x1, x0, anch);
      if (nodolGlifo != glifoLinea->listaGlifos->primero) {
        printf ("  %4d", x0 - x1_ant);
        if (x0 - x1_ant > 3 * anchpauta)
           printf (" <<<==");
        }
      printf ("\n");
      x1_ant = x1;
      }
    }
}

lista listaDelistasDepalabras (tglifo glifoLinea)
{
  tnodolglifo nodolGlifo;
  tglifo glifopal;
  lista llpals, lpals;
  int anchpauta;
  tvent ventpal;
  int x1, x0, anch, x1_ant;
  anchpauta = glifoLinea -> base - glifoLinea -> alturax ;
  llpals = listaNueva ();
  for (nodolGlifo = glifoLinea->listaGlifos->primero;
       nodolGlifo !=  0L;
       nodolGlifo = nodolGlifo->siguiente) {
    glifopal = nodolGlifo->aglifo;
    if (glifopal->tipo == glifCompPal) {
      ventpal   = glifopal->venDeGlifo;
      x0 = ventpal -> dx ;
      anch = ventpal -> tx;
      x1 = x0 + anch - 1 ;
      if (nodolGlifo == glifoLinea->listaGlifos->primero) {
        lpals = listaNueva ();
        aniadeafinlista (llpals, (tpgen) lpals);
        }
      else { //  (nodolGlifo != glifoLinea->listaGlifos->primero)
        if (x0 - x1_ant > 3 * anchpauta) {
          lpals = listaNueva ();
          aniadeafinlista (llpals, (tpgen) lpals);
          }
        }
      aniadeafinlista (lpals, (tpgen) glifopal);
      x1_ant = x1;
      }
    }
  return llpals;
}

typedef struct teysdepautas{
  int base, alturax, anch, dist_bases, dist_alturas;
  } * tysdepautas;

tysdepautas nuevaysdepautas ()
{
  return (tysdepautas) malloc (sizeof(struct teysdepautas));
}

lista listaysdePautas (tglifo glifoColumnaP)
{
  tnodolglifo nodolGlifo;
  tglifo glifol;
  tvent ventl;
  int base, alturax, anch, base_ant, alturax_ant;
  lista lys;
  tysdepautas ysdepautas;
  lys = listaNueva ();
  for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
       nodolGlifo !=  0L;
       nodolGlifo = nodolGlifo->siguiente) {
    glifol = nodolGlifo->aglifo;
    if (glifol->tipo == glifCompLin) {
      ysdepautas = nuevaysdepautas ();
      ventl   = glifol->venDeGlifo;
      base    = glifol -> base + ventl -> dy ;
      alturax = glifol -> alturax + ventl -> dy ;
      anch    = base - alturax;
      ysdepautas -> base    = base ;
      ysdepautas -> alturax = alturax ;
      ysdepautas -> anch    = anch ;
      // printf (" %4d %4d %4d", base, alturax, anch);
      if (nodolGlifo != glifoColumnaP->listaGlifos->primero) {
        // printf (" %4d %4d", base - base_ant, alturax - alturax_ant);
        ysdepautas -> dist_bases   = base    - base_ant ;
        ysdepautas -> dist_alturas = alturax - alturax_ant ;
        }
      // printf ("\n");
      base_ant    = base;
      alturax_ant = alturax;
      aniadeafinlista (lys, (tpgen) ysdepautas );
      }
    }
  return lys;
}

void detectaCabecerayPie (Boolean *hayCab, Boolean *hayPie, lista lys)
{
 int l;
 int separ_supn, separ_sup1;
 int separ_infn, separ_inf1;
 tysdepautas ysdep2, ysdep3, ysdep4;
 tysdepautas ysdepb1, ysdepb2, ysdepb3;
 l = longLista (lys);
 if (l >= 4) {
   ysdep2 = lys->primero->siguiente->aitem;
   ysdep3 = lys->primero->siguiente->siguiente->aitem;
   ysdep4 = lys->primero->siguiente->siguiente->siguiente->aitem;
   separ_supn = (ysdep3->dist_bases + ysdep4->dist_bases ) / 2;
   separ_sup1 = ysdep2->dist_bases ;
   *hayCab =separ_sup1 * 10 > separ_supn * 14 ;
   if (*hayCab)
     if (d_valori >= 10)
       printf (" primera linea mas separada: %4d %4d %4d\n",
                ysdep2->dist_bases, ysdep3->dist_bases, ysdep4->dist_bases);
   // 
   ysdepb1 = lys->ultimo->aitem;
   ysdepb2 = lys->ultimo->anterior->aitem;
   ysdepb3 = lys->ultimo->anterior->anterior->aitem;
   separ_infn = (ysdepb2->dist_bases + ysdepb3->dist_bases ) / 2;
   separ_inf1 = ysdepb1->dist_bases ;
   *hayPie =separ_inf1 * 10 > separ_infn * 14 ;
   if (*hayPie)
     if (d_valori >= 10)
       printf (" ultima linea mas separada: %4d %4d %4d\n",
                ysdepb1->dist_bases, ysdepb2->dist_bases, ysdepb3->dist_bases);
   }
}

void cambiosparanumArab (char *b2, char *b)
{
  char c;
  int i2, i, l;
  l = strlen (b);
  i2 = 0;
  for (i=0; i<l; i++) {
    c = b[i];
    switch (c) {
      case ' ':
        break;
      case 'O':
      case 'o':
        b2[i2++] = '0';
        break;
      case '|':
      case 'l':
      case 'I':
        b2[i2++] = '1';
        break;
      default:
        b2[i2++] = c;
        break;
      }
    }
  b2[i2] = '\0';
}

Boolean numeroArabigoDestr (int *na, char *b)
{
  int i, l, n;
  char c;
  Boolean esnum;
  n = 0;
  *na = -1;
  esnum = TRUE;
  l = strlen (b);
  for (i=0; i<l; i++) {
    c = b[i];
    if ((c >= '0') && (c <= '9'))
      n = n* 10 + (c - '0');
    else {
      esnum = FALSE;
      break;
      }
    }
  // printf ("numeroArabigoDestr: %3d %3d %3d\n", i, esnum, n);
  *na = n;
  return esnum;
}

Boolean numeroArabigoDelistagl (int *na, lista lisg)
{
  char buf [512], buf2[512];
  tnodol nodol;
  Boolean esnum;
  // buf := caracteres de lista de glifos (lisg);
  buf [0] = '\0';
  for (nodol=lisg->primero; nodol != 0L; nodol=nodol->siguiente) {
     escribeEnBufLetrasdeGlifosenLista (buf, (tglifo) nodol->aitem);
     if (nodol->siguiente != 0L)
       strcat (buf, " ");
     }
  if (d_valori >= 10)
    printf (" en numeroArabigoDelistagl: %s\n", buf);
  cambiosparanumArab (buf2, buf);
  if (d_valori >= 10)
    printf (" en numeroArabigoDelistagl: %s\n", buf2);
  esnum = numeroArabigoDestr (na, buf2);
  if (esnum) {    // temporal_tagnumpag
    glifcom_tagnumpag = (tglifo) lisg->primero->aitem;
    gliffin_tagnumpag = (tglifo) lisg->ultimo->aitem;
    }
  return esnum;
}

void escribeysdePautas (lista lys)
{
  tnodol nodol;
  tysdepautas ysdepautas;
  for (nodol = lys->primero; nodol !=  0L; nodol = nodol->siguiente) {
    ysdepautas = (tysdepautas) nodol->aitem ;
    printf (" %4d %4d %4d", ysdepautas->base, ysdepautas->alturax, ysdepautas->anch);
    if (nodol != lys->primero) {
      printf (" %4d %4d", ysdepautas->dist_bases, ysdepautas->dist_alturas);
      }
    printf ("\n");
    }
}

void escribePautas (tglifo glifoColumnaP)
{
  lista lys;
  tglifo lineaprim, lineault;
  Boolean hayCab, hayPie;
  Boolean enlis11, enlis12, enlis91;
  int nlis11, nlis12, nlis91;
  lista llpalsprim, llpalsult;
  enlis11 = FALSE;
  enlis12 = FALSE;
  enlis91 = FALSE;
  lys = listaysdePautas (glifoColumnaP);
  // escribeysdePautas (lys);
  detectaCabecerayPie (&hayCab, &hayPie, lys);
  if (hayCab) {
    lineaprim = glifoColumnaP->listaGlifos->primero->aglifo;
    //   printf ("\n");
    if (d_valori >= 15)
      escribeEspacios (lineaprim);
    llpalsprim = listaDelistasDepalabras (lineaprim);
    if (d_valori >= 10)
      printf ("partes primera linea: %3d\n", longLista (llpalsprim));
    enlis11 = numeroArabigoDelistagl (&nlis11, (lista) llpalsprim->primero->aitem);
    if (longLista (llpalsprim) >= 2) 
      enlis12 = numeroArabigoDelistagl (&nlis12, (lista) llpalsprim->primero->siguiente->aitem);
    }
  if (hayPie) {
    lineault = glifoColumnaP->listaGlifos->ultimo->aglifo;
    //   printf ("\n");
    // escribeEspacios (lineault);
    llpalsult =  listaDelistasDepalabras (lineault);
    if (d_valori >= 10)
      printf ("partes ultima linea: %3d\n", longLista (llpalsult));
    enlis91 = numeroArabigoDelistagl (&nlis91, (lista) llpalsult->primero->aitem);
    }
  if ((y_valori == 2) || (y_valori == 3)) {
    if (enlis11)
      printf ("numero arriba, izquierda: %4d\n", nlis11);
    if (enlis12)
      printf ("numero arriba, derecha: %4d\n",   nlis12);
    if (enlis91)
      printf ("numero abajo: %4d\n", nlis91);
    }
}

void baseyalturaxDeGlifo (int *base, int *alturax, tglifo glifo)
{
  int baseEnLinea, alturaxEnLinea;
  tglifo gl;
  tvent veng_ais;
  int altural;
  // aislado: sudokus, numeros de pagina, letras capitulares
  if (tomaValordeListaAtributos (glifo->venDeGlifo->atributs, "capitular") != 0L) {
    veng_ais = glifo->venDeGlifo;
    *base     = veng_ais->dy + veng_ais->ty - 1 ;
    altural   = veng_ais->dy ;
    *alturax  = (altural * 2 + (*base)) / 3;   // coherente con 96, 144, 48
    return ;
    }
  gl = glifo;
  while (gl->base == -1) {
    if (gl->glifBase == 0L) {
      printf ("ocre: error en glifos.baseyalturaxDeGlifo, no encontrada base\n");
      tirarPrograma ();
      exit (2);
      }
    gl = gl->glifBase ;
    /*
    if (gl->base != 0L)
      gl = gl->glifBase ;
    else
      gl = gl->venDeGlifo->venBase->glifoDeVen;
      */
    }
  baseEnLinea    = gl->base ;
  alturaxEnLinea = gl->alturax ;
  *base     = baseEnLinea      + gl->venDeGlifo->dy;
  *alturax  = alturaxEnLinea   + gl->venDeGlifo->dy;
}

void alineamientoNormalizado (int *dyNorm, int *dy2Norm, int *tyNorm, tglifo glifo)
{
  int localt = 0;
  int base, alturax;
  int baseMenosAlturax;
  int dy, ty, dy2;
  int dxr;
  // aislado: sudokus, numeros de pagina, letras capitulares
  if (tomaValordeListaAtributos (glifo->venDeGlifo->atributs, "capitular") != 0L) {
    *dyNorm = 96; *dy2Norm = 144; *tyNorm = 48;   // aislado
  }
  else {
    baseyalturaxDeGlifo (&base, &alturax, glifo) ;
            if (localt && glifo->letras != 0L && glifo->letras[0] == 'A' &&
                glifo->nid == 888) {
              printf ("base: %4d, alturax: %4d\n", base, alturax);
              describeGlifo (glifo, 0);
              }
    // dy = glifo->venDeGlifo->dy;
    ty = glifo->venDeGlifo->ty;
    desplazamientosBase2 (&dxr, &dy, glifo->venDeGlifo);
    dy2 = dy + ty;
    baseMenosAlturax = max(1, base -alturax);
            if (localt && glifo->letras != 0L && glifo->letras[0] == 'A' &&
                glifo->nid == 888) {
              printf ("dy: %4d, dy2: %4d, base-altx: %4d\n", dy, dy2, baseMenosAlturax);
              }
    *dyNorm  = 112+ ((dy  - alturax) * 32 - 16)/ baseMenosAlturax;
    *dy2Norm = 112+ ((dy2 - alturax) * 32 + 16)/ baseMenosAlturax;
    *tyNorm  = *dy2Norm - *dyNorm ;
            if (localt && glifo->letras != 0L && glifo->letras[0] == 'A' &&
                glifo->nid == 888) {
              printf ("dyNorm: %4d, dy2Norm: %4d, tyNorm: %4d\n",
                       *dyNorm, *dy2Norm, *tyNorm);
              }
  }
}

char ** comentarioAlineamiento (tglifo glifo)
                /* e inclinacion si es <> 0 */
{
  char buf[128];
  char ** comen2;
  int dyNorm, tyNorm, dy2Norm;
  alineamientoNormalizado ( &dyNorm, &dy2Norm, &tyNorm, glifo);
  // dyNorm = 96; dy2Norm = 144; tyNorm = 48;   //  SOLO para numeros de pagina
  if (glifo->venDeGlifo->incl == 0) 
    sprintf (buf, "dyNorm=%4d dy2Norm=%4d tyNorm=%4d", dyNorm, dy2Norm, tyNorm);
  else
    sprintf (buf, "dyNorm=%4d dy2Norm=%4d tyNorm=%4d inclvc=%4d",
                   dyNorm, dy2Norm, tyNorm, glifo->venDeGlifo->incl);
  listaAarrayConcopia (&comen2, 1, buf);
  return comen2;
}


// -------------------- aplicadoR al glifo --------------------
// ----------

typedef struct tenmdirn{
  char * ndir;
  int  * n;
  } * tndirn;

// Boolean soloReconPreg = TRUE;
// Boolean soloReconPreg = FALSE;
// Boolean escribeTodos  = TRUE;
 Boolean escribeTodos  = FALSE;

// void kkk (tglifo glifo, int nc)
// {
//   printf ("\n");
//   printf ("%3d\n",nc);
//   describeGlifo (glifo, 2);
//   printf ("#\n");
//   describeGlifo (glifo->glifBase, 0);
//   describeGlifo (glifo->glifBase->glifBase, 0);
//   describeGlifo (glifo->glifBase->glifBase->glifBase, 0);
// }

//        entre 05 y 10
void subdirdeGlifo (char *sd, tglifo glifo)
{
  if (glifo->venDeGlifo->incl == 0) {
    if ((glifo->recon == reconDcswft) && (glifo->recindc >=5)) {
      sprintf(sd, "/r%02d", glifo->recindc);
      }
    else
      strcpy (sd, "/r05");
/*
    if ((glifo->recon == reconDcswft) && (glifo->recindc ==5))
      strcpy (sd, "/r5");
    else if ((glifo->recon == reconDcswft) && (glifo->recindc ==4))
      strcpy (sd, "/r4");
    else
      strcpy (sd, "/r3");
*/
    }
  else {  // ... incl != 0
    if ((glifo->recon == reconDcswft) && (glifo->recindc >=5))
      sprintf(sd, "/i%02d", glifo->recindc);
    else
      strcpy (sd, "/i05");
/*
    if ((glifo->recon == reconDcswft) && (glifo->recindc ==5))
      strcpy (sd, "/i5");
    else if ((glifo->recon == reconDcswft) && (glifo->recindc ==4))
      strcpy (sd, "/i4");
    else
      strcpy (sd, "/i3");
*/
    }
}

void escribeVentanadeGlifoCar (tglifo glifo, tpgen gndirn)
{
  char nf[128];
  char sd[64];
  char ** comen2;
  int nc;
  tndirn ndirn;
  // if ( (! soloReconPreg) ||
  //      (glifo->recon == reconPreg) ) {
  ndirn = (tndirn) gndirn;
  nc = *(ndirn->n);
  // if ((nc>=64) && (nc <=70))
  //  kkk (glifo, nc);
  if (p_valori == 35) {
    if (glifo->recon != reconPreg) 
      return;
    escribeTodos = TRUE;
    }
  if (escribeTodos)
    ponNombreSim2 (nf, ndirn->ndir, "/td", glifo->letras, nc);
  else {
    subdirdeGlifo (sd, glifo);
    ponNombreSim2 (nf, ndirn->ndir, sd, glifo->letras, nc);
    }
/*
  if (escribeTodos ||
      ! ((glifo->recon == reconDcswft) &&
         (glifo->recindc >=4) )) {
    ponNombreSim (nf, ndirn->ndir, glifo->letras, nc);
  }
  else if (glifo->recindc <=4){      // 4 => no se guarda el nivel 5
    ponNombreSim2 (nf, ndirn->ndir, "b", glifo->letras, nc);
    }
*/
  comen2 = comentarioAlineamiento (glifo);
  escribeVentanaLimMascomentarios (glifo->venDeGlifo, nf, comen2);
  free (comen2);
  nc ++ ;
  *(ndirn->n) = nc;
}

void escribeVentanasdeGlifosenLista (tglifo glifo, int *nc, char *ndir)
{
  struct tenmdirn endirn;
  endirn.n    = nc;
  endirn.ndir = ndir;
  aplicaGtRFncD (glifo, glifCar, escribeVentanadeGlifoCar, (tpgen) &endirn);
}

// ---------- en obras-1

void numeraGlifoCar (tglifo glifo, tpgen gndirn)
{
  int nc;
  tndirn ndirn;
  ndirn = (tndirn) gndirn;
  nc = *(ndirn->n);
  glifo->ideglifo = nc;
  nc ++ ;
  *(ndirn->n) = nc;
}

void numeraGlifosenLista (tglifo glifo, int *nc)
{
  struct tenmdirn endirn;
  endirn.n    = nc;
  aplicaGtRFncD (glifo, glifCar, numeraGlifoCar, (tpgen) &endirn);
}


// ----------

void marcaGlifoCarNoReconocido (tglifo glifo)
{
  if (glifo->recon == reconNulo)
    pintaRectIntVent (glifo->venDeGlifo);
}

void marcaGlifosNoReconocidos (tglifo glifoColumnaP) 
{
  aplicaGtRFn (glifoColumnaP, glifCar, marcaGlifoCarNoReconocido);
}

// ----------

void anyadeGlifoAlista(tglifo glifo, tpgen datos)
{
  aniadeafinlista ((lista) datos, (tpgen) glifo);
}

void anyadeGlifoLAlista(tglifo glifo, tpgen datos)
{
  if (glifo->parteLogAnt == 0L)
    aniadeafinlista ((lista) datos, (tpgen) glifo);
}

// palabras N
void listadePalabrasEnGlifo (lista *nlista, tglifo glifo)
{
  lista l;
  l = listaNueva ();
  aplicaGtRFncD (glifo, glifCompPal, anyadeGlifoAlista, (tpgen) l);
  *nlista = l;
}

// palabras Logicas
void listadePalabrasLenGlifo (lista *nlista, tglifo glifo)
{
  lista l;
  l = listaNueva ();
  aplicaGtRFncD (glifo, glifCompPal, anyadeGlifoLAlista, (tpgen) l);
  *nlista = l;
}

// ----------

tglifo glifoUltimoconchar (tglifo glifoc)
{
  tglifo gul;
  tnodolglifo nodolGlifo;
  switch (glifoc->tipo) {
    case glifCompLin :
    case glifCompPal :
    case glifCompSec :
      for (nodolGlifo = glifoc->listaGlifos->ultimo;
           nodolGlifo != 0L; nodolGlifo = nodolGlifo->anterior){
	gul = glifoUltimoconchar (nodolGlifo->aglifo) ;
	if (gul != 0L)
          return gul;
	}
      return 0L;
      break ;
    case glifCar :
      // if (glifoc->recon != reconNulo)
      return glifoc ;
      // else
      //   return 0L;
      break ;
    default :
      return 0L;
      break ;
    }
}

Boolean glifoAcabaenchar (tglifo glifoc, char ch)
{
  tglifo glifoul;
  int l;
  glifoul = glifoUltimoconchar (glifoc) ;
  if (glifoul == 0L)
    return FALSE;
  if (glifoul->recon == reconNulo)
    return FALSE;
  l = strlen (glifoul->letras);
  return glifoul->letras[l-1] == ch ;
}

Boolean glifoAcabaenGuion (tglifo glifoc)
{
  tglifo glifoul;
  // int l;
  char buf[120];
  glifoul = glifoUltimoconchar (glifoc) ;
  if (glifoul == 0L)
    return FALSE;
  if (glifoul->recon == reconNulo)
    return FALSE;
  // rollo de utf8
  sustrDeUtf8 (buf, glifoul->letras);
  // l = strlen (buf);
  // printf ("------------ l: %3d %s\n",l, buf);
  return  strcmp (buf, "u2015") == 0 ;
}

void cambiaUltimochar (tglifo glifoc, char *chs)
{
  tglifo glifoul;
  glifoul = glifoUltimoconchar (glifoc) ;
  if (glifoul == 0L) {
    printf ("ocre: error en glifos.cambiaUltimochar\n");
    exit (1);
    }
  if (glifoul->recon == reconNulo) {
    printf ("ocre: error en glifos.cambiaUltimochar\n");
    exit (1);
    }
  glifoul->letras = strdup (chs) ;
}


// ----------

void anyadeaParteLetrasConocidas (tglifo glifo, tpgen datos)
{
  char *tira;
  lista lis = (lista) datos;
  if (glifo->recon == reconNulo){
    //// anyadeafinlista parte nueva con tira vacia
    tira = (char *) malloc (100);
    tira[0] = '\0';
    aniadeafinlista (lis, tira);
    }
  else {
    //// anyade al ultimo elemento los chars del glifo
    //   como utf8
    strncat ((char *)(lis->ultimo->aitem), glifo->letras, 100);
    //   como ascii
    // char carsus[1024];
    // ssalidaDeUtf (carsus, glifo->letras);
    // strncat ((char *)(lis->ultimo->aitem), carsus, 100);
    }
}

lista partesDePalabraNenGlifo (tglifo glifo)
{
  lista lista;
  char *tira;
  lista = listaNueva ();
  //// anyadeafinlista parte nueva con tira vacia
    tira = (char *) malloc (100);
    tira[0] = '\0';
    aniadeafinlista (lista, tira);
  aplicaGtRFncD (glifo, glifCar, anyadeaParteLetrasConocidas, (tpgen) lista);
  return lista;
}

// 1 caracter de longitud 1 octeto
void quitaAlfinal (char *tira, char car)
{
  int l;
  l = strlen (tira);
  if (l != 0)
    if (tira[l-1] == car)
      tira[l-1] = '\0';
}

lista partesDePalabraLenGlifo (tglifo glifo)
{
  lista lista;
  char *tira;
  lista = listaNueva ();
  //// anyadeafinlista parte nueva con tira vacia
    tira = (char *) malloc (100);
    tira[0] = '\0';
    aniadeafinlista (lista, tira);
  aplicaGtRFncD (glifo, glifCar, anyadeaParteLetrasConocidas, (tpgen) lista);
  if (glifo->parteLogSig == 0L)
    return lista;
  else {
    // '-' es un caracter de logitud un octeto (en utf8)
    quitaAlfinal ( (char *)lista->ultimo->aitem, '-');
    aplicaGtRFncD (glifo->parteLogSig, glifCar, anyadeaParteLetrasConocidas, (tpgen) lista);
    return lista;
    }
}

// ----------

void cuentaGlifosIncognita(tglifo glifo, tpgen datos)
{
  int * n = (int *) datos;
  if (glifo->recon == reconNulo)
    (* n) ++ ;
}

int nincognitasEnGlifo (tglifo glifo)
{
  int n = 0;
  aplicaGtRFncD (glifo, glifCar, cuentaGlifosIncognita, (tpgen) &n);
  return n;
}

int nincognitasEnLGlifo (tglifo glifo)
{
  int n = 0;
  aplicaGtRFncD (glifo, glifCar, cuentaGlifosIncognita, (tpgen) &n);
  if (glifo->parteLogSig == 0L)
    return n;
  else {
    aplicaGtRFncD (glifo->parteLogSig, glifCar, cuentaGlifosIncognita, (tpgen) &n);
    return n;
    }
}

// ----------

void anyadealistaGlifoIncognita(tglifo glifo, tpgen datos)
{
  if (glifo->recon == reconNulo)
    aniadeafinlista ((lista) datos, (tpgen) glifo);
}

lista listaIncognitasEnGlifo (tglifo glifo)
{
  lista lista;
  lista = listaNueva ();
  aplicaGtRFncD (glifo, glifCar, anyadealistaGlifoIncognita, (tpgen) lista);
  return lista ;
}

lista listaIncognitasEnGlifoL (tglifo glifo)
{
  lista lista;
  lista = listaNueva ();
  aplicaGtRFncD (glifo, glifCar, anyadealistaGlifoIncognita, (tpgen) lista);
  if (glifo->parteLogSig == 0L)
    return lista ;
  else {
    aplicaGtRFncD (glifo->parteLogSig, glifCar, anyadealistaGlifoIncognita, (tpgen) lista);
    return lista ;
    }
}

// ----------

typedef struct telistayletr{
  lista lista;
  char  * letra;
  } * tlistayletr;

void anyadealistaGlifoCarConLetras(tglifo glifo, tpgen gdatos)
{
  tlistayletr datos = (tlistayletr) gdatos;
  if (strcmp(glifo->letras, datos->letra)==0)
    aniadeafinlista (datos->lista, (tpgen) glifo);
}

lista listaGlifosConLetraEnGlifo (tglifo glifo, char *letra)
{
  struct telistayletr datos;
  datos.lista = listaNueva ();
  datos.letra = letra;
  aplicaGtRFncD (glifo, glifCar, anyadealistaGlifoCarConLetras, (tpgen) &datos);
  return datos.lista ;
}

// ----------

typedef struct te2char{
  char ch1, ch2;
} * t2char;

typedef struct te2str {
  char *chs1, *chs2;
} * t2str;

void cambiaEnglifoCar(tglifo glifo, tpgen datos)
{
  char cant  = ((t2char)datos)->ch1;
  char cdesp = ((t2char)datos)->ch2;
  if (glifo->letras[0] == cant)
    glifo->letras[0] = cdesp;
}

void cambiaNEnGlifo (tglifo glifo, char cant, char cdesp)
{
  struct te2char datos;
  datos.ch1 = cant;
  datos.ch2 = cdesp;
  aplicaGtRFncD (glifo, glifCar, cambiaEnglifoCar, (tpgen) &datos);
}

void cambiaEnglifoStr(tglifo glifo, tpgen datos)
{
  char *sant  = ((t2str)datos)->chs1;
  char *sdesp = ((t2str)datos)->chs2;
  if (strcmp(glifo->letras, sant) == 0)
    glifo->letras = sdesp;
}

void cambiaStrNEnGlifo (tglifo glifo, char *sant, char *sdesp)
{
  struct te2str datos;
  datos.chs1 = sant;
  datos.chs2 = sdesp;
  aplicaGtRFncD (glifo, glifCar, cambiaEnglifoCar, (tpgen) &datos);
}

// ----------

void  corrigeGuionesFindeLinea (tglifo glifoColumnaP)
{
  tglifo glifoLin, glifoPalult;
  tnodolglifo nodolGlifo;
  for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
       nodolGlifo != 0L; nodolGlifo = nodolGlifo->siguiente) {
    glifoLin = nodolGlifo->aglifo;
    if (glifoLin->tipo == glifCompLin) {
      glifoPalult = glifoLin->listaGlifos->ultimo->anterior->aglifo ; // -camb.linea
      // describeGlifo (glifoPalult, 2);
      if (glifoAcabaenGuion (glifoPalult)) {
        // enlaza ultimaPalabra esa linea con siguiente palabra (0L).
        // enlazaLogGlifos (glifoPalult, (tglifo) 0L);
        cambiaUltimochar (glifoPalult, "-");
        }
      }
    }
}

// ----------

void enlazaPalabrasPartidas (tglifo glifoColumnaP)
{
  tglifo glifoLin, glifoPalult;
  tnodolglifo nodolGlifo;
  for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
       nodolGlifo != 0L; nodolGlifo = nodolGlifo->siguiente) {
    glifoLin = nodolGlifo->aglifo;
    if (glifoLin->tipo == glifCompLin) {
      glifoPalult = glifoLin->listaGlifos->ultimo->anterior->aglifo ; // -camb.linea
      // describeGlifo (glifoPalult, 2);
      if (glifoAcabaenchar (glifoPalult, '-')) {
        // enlaza ultimaPalabra esa linea con siguiente palabra (0L).
        enlazaLogGlifos (glifoPalult, (tglifo) 0L);
        }
      }
    }
}


void enlazaPalabraPartida (tglifo glifoPalabra)
{
  // tglifo glifoLinea;
  // glifoLinea = glifoPalabra->glifBase;
  // printf (">-->");
  // describeGlifo (glifoLinea, 2);
  // printf (">->");
  // describeGlifo (glifoPalabra, 2);
  if ((glifoPalabra->tipo == glifCompPal) &&
      (glifoPalabra->glifBase->listaGlifos->ultimo->anterior->aglifo
                                              // -camb.linea
         == glifoPalabra)) {
    if (glifoAcabaenchar (glifoPalabra, '-')) {
      // enlaza ultimaPalabra esa linea con siguiente palabra (0L).
      enlazaLogGlifos (glifoPalabra, (tglifo) 0L);
      }
    }
}

// ----------

// recorre las lineas de glifoColumnaP. 
//   cuando la primera linea cuyo (base) dy sea mayor que dy de ventCap
//        pon la ventana capitular al comienzo de esa linea.
//  (comparamos dy de glifoColumnaP relativos a vent
//       hay que restar vent-> a dy de la linea
void ponCapitularenGlifoCP (tglifo glifoColumnaP, tvent ventCap, tvent vent)
{
  tglifo glifoLin;
  tglifo glifoPal;
  tglifo glifoCap;
  Boolean linea_ok;
  tnodolglifo nodolGlifo;
  linea_ok = FALSE;
  for (nodolGlifo = glifoColumnaP->listaGlifos->primero;
       nodolGlifo != 0L; nodolGlifo = nodolGlifo->siguiente) {
    if (nodolGlifo->aglifo->tipo == glifCompLin) {
      glifoLin = nodolGlifo->aglifo;
      // printf ("%4d %4d %4d %4d \n",
      //               glifoLin->venDeGlifo->dy, glifoLin->venDeGlifo->ty,
      //               ventCap->dy, vent->dy);
      if (glifoLin->venDeGlifo->dy + glifoLin->venDeGlifo->ty  >
          ventCap->dy - vent->dy ) {
        linea_ok = TRUE;
        break;
        }
      }
    }
  if (linea_ok) {
          // como primera palabra, o como primera letra de ..
    for (nodolGlifo = glifoLin->listaGlifos->primero;
         nodolGlifo != 0L; nodolGlifo = nodolGlifo->siguiente) {
      if (nodolGlifo->aglifo->tipo == glifCompPal) {
        glifoPal = nodolGlifo->aglifo;
        // describeGlifo (glifoPal, 1);
        glifoCap = GLIfoDeVen(ventCap) ;
        aniadeGlifoacomlista (glifoPal->listaGlifos, glifoCap);
        glifoCap->glifBase = glifoPal;
        break;
        }
      }
    }
  // describeGlifo (glifoPal, 1);
}

