
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "misc2.h"

/* crea un vector de tamanyo tam, con valor a ceros,
   salvo un triangulo simetrico con centro en ct y altura alt .
   Para modelo de funcion de transferencia de un punto en un escaner */
void vector_con_triangulo (vectint *nv, int tam, int ct, int alt)
{
  vectint v;
  int x, dx;
  /* comprobaciones */
  if ( ((ct-alt)<0) | ((ct+alt)>tam) ) {
    printf ("ocre.misc2.vector_con_triangulo, error en params. tam=%4d, ct=%4d, alt=%4d\n",
             tam, ct, alt);
    exit (37);           /* arbitrario */
    }
  v = (vectint) malloc (tam * sizeof (int));
  for (x=0; x<tam; x++)
    v [x] = 0;
  for (dx=0; dx<alt; dx++) {
    v [ct-dx] = alt-dx;
    v [ct+dx] = alt-dx;
    }
  *nv = v;
}

/* crea un vector de tamanyo tam, con valor a ceros,
   salvo un rectangulo con comienzo en cm, base bs y altura alt .
   Para modelo de funcion de transferencia de un punto en un escaner */
void vector_con_rectangulo (vectint *nv, int tam, int cm, int bs, int alt)
{
  vectint v;
  int x, dx;
  /* comprobaciones */
  if ( (cm<0) | ((cm+bs)>tam) ) {
    printf ("ocre.misc2.vector_con_rectanculo, error en params. tam=%4d, cm=%4d, bs=%4d, alt=%4d\n",
             tam, cm, bs, alt);
    exit (37);           /* arbitrario */
    }
  v = (vectint) malloc (tam * sizeof (int));
  for (x=0; x<tam; x++)
    v [x] = 0;
  for (dx=0; dx<bs; dx++) {
    v [cm+dx] = alt;
    }
  *nv = v;
}

/* crea un vector de tamanyo tam, con  valor lejano h0,
 * surco centrado en cent, profundidad prof, y anchura de media profundidad 2*anch
 */
void vector_con_surco (vectint *nv, int tam, int h0, int cent, int prof, int anch)
{
  vectint v;
  int x;
  // int dx;
  v = (vectint) malloc (tam * sizeof (int));
  for (x=0; x<tam; x++)
    v [x] = h0 - (prof * anch) / (abs(x - cent) + anch) ;
  *nv = v;
}

