
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "dcsw/treesdcsw.h"
#include "base.h"
#include "config.h"
#include "idiom.h"
#include "opcns.h"


/******************    Opciones    ******************/

static struct option opciones_largas[] = {
   {"fulana", 0, 0, 0}, 
   {"mengana", 1, 0, 0},
   {0, 0, 0, 0}
};

static void escribeAyuda (int mas)
{
// con punto no aparece en  -h  (ayuda)
  static char *ayuda[] ={
    ".  -a dirArb   directorio con arboles",
    ".  -A          Academia (DRAE)",
    "   -b          book, libro",
    ".  -C          clean, limpio (el caracter), refinado",
    "   -d          depuracion, nivel",
    ".       1      una sola vez, rutinas",
    ".       2      inclinacion",
    ".       3      n veces: grises, lineas, comentarios",
    ".       4      n+ veces, caracteres",
    ".       5      n * n veces histograma caracteres",
    ".  -D          diccionario",
    ".  -e          estadisticas (al final)",
    ".  -E          estructurada, salida, y etiquetada",
    ".  -f file     fichero para salida",
    ".  -g tipo     salida etiquetada (taged)",
    "   -h          ayuda, opciones y significado",
    ".  -k          k, akaba/kill proceso antes de preg",
    "   -l          lenguaje",
    ".  -m          umbral para el reconocimiento",
    ".  -n          comienzo de numeracion de caracteres",
    ".  -N          escribe el numero de glifo del primer caracter de la lista",
    "   -p          proceso",
    ".       3      presenta segmentacion ajustada a caracteres",
    "        5      escribe los caracteres, cada uno en un fichero, bajo ./arm1",
    ".       8      histograma horizontal-2 y paraCorte",
    ".      22      escribe las palabras y caracteristicas para inclinacion",
    ".      24      presenta el histograma 3 vert. cuadr. para determ. inclinacion",
    "   -P          parcela",
    ".  -q          (interactivo) /query, pregunta",
    ".       5      pregunta el caracter enseguida",
    "   -R          cambio de linea con CR/LF",
    ".  -s          las preguntas, no las hace",
    ".  -S          recuadra las preguntas y no las hace",
    ".  -t          =0 recto (por omision), =1 cursiva, =2 segun",  // tipo .. de letra
    ".  -T          toleracion en la comparacion",
    "   -u          unicode a la salida",
    "   -v          version",
    ".  -x          distancia max(d1,d2)",
    ".  -X          valores para probar, array",
    ".  -y          trazas",
    ".  -z          acaba en silencio",
    ".        1     pautas",
    "#"
  };
  int la;
  for (la=0;ayuda[la][0]!='#';la++)
    if (mas || (ayuda[la][0] != '.'))
      printf ("%s\n", ayuda[la]) ;
}

extern char *optarg;

void inicopc ()
{
  a_opcion = TRUE;
  a_valor  = strdup (DIRLIB);
  t_valori  = 0 ;
  A_opcion = FALSE;
  b_opcion = FALSE;
  C_opcion = FALSE;
  d_opcion = FALSE;
  D_opcion = FALSE;
  e_opcion = FALSE;
  E_opcion = FALSE;
  f_opcion = FALSE;
  g_opcion = FALSE;
  h_opcion = FALSE;
  H_opcion = FALSE;
  k_opcion = FALSE;
  l_opcion = FALSE;
  m_opcion = FALSE;
  n_opcion = FALSE; n_valori = 0;
  N_opcion = FALSE;
  P_opcion = FALSE;
  q_opcion = FALSE;
  R_opcion = FALSE;
  s_opcion = FALSE;
  S_opcion = FALSE;
  t_opcion = FALSE;
  T_opcion = FALSE;
  u_opcion = FALSE;
  v_opcion = FALSE;
  v_opcion = FALSE;
  z_opcion = FALSE;
//  x_opcion = FALSE;
  x_opcion = TRUE;
  X_opcion = FALSE;
  y_opcion = TRUE;
  q_opcion = TRUE; q_valori = 3;
}

void  getoffiopc ()
{
  char finiocre[100];
  char *home;
  FILE * fd;
  char b0[128], b1[128];
  if ((home = getenv("HOME")) != (char *)0L){
    strcpy (finiocre, home);
    strncat (finiocre, "/.ocrerc", 100);
    // printf (":%s:\n", finiocre);
    fd = fopen (finiocre, "r");
    if (fd != (FILE *) NULL) {
      fscanf (fd, "%s %s ", b0, b1);
      if (strcmp(b0, "language")==0) {
        l_opcion = TRUE;
	l_valor_idiom = idiomaDeStr (b1);
        }
      }
    }
}

void getofclopc (int argc, char **argv)
{
  int c, err;
  int il;
  // float v_umbralValPropDef;
  err      = FALSE;
  // while ((c = getopt(argc, argv, "a:Ab:C:d:Def:g:hHkl:n:Np:Pq:RsSt:T:uvxX:y:")) != EOF){
  while (((c = getopt_long(argc, argv,
                           "a:Ab:C:d:Def:g:hHkl:m:n:Np:Pq:RsSt:T:uvxX:y:",
                            opciones_largas, &il)) != EOF) && (! err)){
    if (c == 0) {
      printf ("opcion %s", opciones_largas[il].name);
      if (optarg)
        printf (" con argument: %s", optarg);
      printf ("\n");
      }
    switch (c){
    case 'a':
      a_opcion = TRUE; a_valor = optarg;
      break;
    case 'A':
      A_opcion = TRUE;
      break;
    case 'b':
      b_opcion = TRUE; b_valor = optarg;
      break;
    case 'C':
      C_opcion = TRUE; C_valor = optarg;
      break;
    case 'd':
      d_opcion = TRUE; d_valor = optarg; d_valori = atoi (d_valor) ;
      break;
    case 'D':
      D_opcion = TRUE;
      break;
    case 'e':
      e_opcion = TRUE;
      break;
    case 'E':
      E_opcion = TRUE;
      break;
    case 'f':
      f_opcion = TRUE; f_valor = optarg;
      break;
    case 'g':
      g_opcion = TRUE; g_valor = optarg; g_valori = atoi (g_valor) ;
      break;
    case 'h':
      h_opcion = TRUE;
      break;
    case 'H':
      H_opcion = TRUE;
      break;
    case 'k':
      k_opcion = TRUE;
      break;
    case 'l':
      l_opcion = TRUE; l_valor = optarg; l_valor_idiom = idiomaDeStr ( l_valor );
      if (l_valor_idiom == idiom_rus)
        u_opcion = TRUE;
      break;
    case 'm':
      m_opcion = TRUE; m_valor = optarg; m_valorf = atof (m_valor) ;
    //  v_umbralValPropDef = pon_umbrValPropDef (m_valorf);
      break;
    case 'n':
      n_opcion = TRUE; n_valor = optarg; n_valori = atoi (n_valor) ;
      break;
    case 'N':
      N_opcion = TRUE;
      break;
    case 'p':
      p_opcion = TRUE; p_valor = optarg; p_valori = atoi (p_valor) ;
      break;
    case 'P':
      P_opcion = TRUE;
      break;
    case 'q':
      q_opcion = TRUE; q_valor = optarg; q_valori = atoi (q_valor) ;
      break;
    case 'R':
      R_opcion = TRUE;
      break;
    case 's':
      s_opcion = TRUE;
      break;
    case 'S':
      S_opcion = TRUE;
      break;
    case 't':
      t_opcion = TRUE; t_valor = optarg; t_valori = atoi (t_valor) ;
      break;
    case 'T':
      T_opcion = TRUE; T_valor = optarg; T_valori = atoi (T_valor) ;
      break;
    case 'u':
      u_opcion = TRUE;
      break;
    case 'v':
      v_opcion = TRUE; printf ("ocre: version 0.044\n");
      exit (0);
      break;
    case 'x':
      x_opcion = TRUE;
      break;
    case 'X':
      X_opcion = TRUE; X_valor = optarg; // X_valori = atoi (X_valor) ;
      X_valori = (int *) malloc(6 * sizeof(int));
      sscanf(X_valor, "%d,%d,%d,%d,%d,%d",
             &X_valori[0], &X_valori[1], &X_valori[2],
	     &X_valori[3], &X_valori[4], &X_valori[5]);
      break;
    case 'y':
      y_opcion = TRUE; y_valor = optarg; y_valori = atoi (y_valor) ;
      break;
    case 'z':
      z_opcion = TRUE;
      break;
    case '?':
      err = TRUE;
      break;
    default:
      err = TRUE;
      break;
    }
  }
  if (err) {
    fprintf(stderr, "uso: %s [-a dirArb -d niv -f -g tipo -h -m umb.rc -n nc0 N -p proc -u -y trazPost -z]\n", argv[0]);
    exit (1);
    }
  if (H_opcion){
    escribeAyuda (TRUE);
    exit (0);
    }
  else if (h_opcion){
    escribeAyuda (FALSE);
    exit (0);
    }
}

void printopc ()
{
  printf ("opcion a %d\n", a_opcion);
  if (a_opcion) printf ("el valor de la opcion a es: %s\n", a_valor);
  printf ("opcion A %d\n", A_opcion);
  printf ("opcion b %d\n", b_opcion);
  printf ("opcion C %d\n", C_opcion);
  printf ("opcion d %d\n", d_opcion);
  if (d_opcion) printf ("el valor de la opcion d es: %s\n", d_valor);
  printf ("opcion D %d\n", D_opcion);
  printf ("opcion e %d\n", e_opcion);
  printf ("opcion E %d\n", E_opcion);
  printf ("opcion f %d\n", f_opcion);
  if (f_opcion) printf ("el valor de la opcion f es: %s\n", f_valor);
  printf ("opcion g %d\n", g_opcion);
  if (g_opcion) printf ("el valor de la opcion g es: %s\n", g_valor);
  printf ("opcion h %d\n", h_opcion);
  printf ("opcion H %d\n", H_opcion);
  printf ("opcion k %d\n", l_opcion);
  printf ("opcion l %d\n", l_opcion);
  if (l_opcion) printf ("el valor de la opcion l es: %s\n", l_valor);
  printf ("opcion q %d\n", q_opcion);
  printf ("opcion m %d\n", m_opcion);
  if (m_opcion) printf ("el valor de la opcion m es: %s\n", m_valor);
  printf ("opcion n %d\n", n_opcion);
  if (n_opcion) printf ("el valor de la opcion n es: %s\n", n_valor);
  printf ("opcion N %d\n", N_opcion);
  printf ("opcion p %d\n", p_opcion);
  if (p_opcion) printf ("el valor de la opcion p es: %s\n", p_valor);
  printf ("opcion P %d\n", P_opcion);
  printf ("opcion q %d\n", q_opcion);
  if (q_opcion) printf ("el valor de la opcion q es: %s\n", q_valor);
  printf ("opcion R %d\n", R_opcion);
  printf ("opcion s %d\n", s_opcion);
  printf ("opcion S %d\n", s_opcion);
  printf ("opcion t %d\n", t_opcion);
  if (t_opcion) printf ("el valor de la opcion t es: %s\n", t_valor);
  printf ("opcion T %d\n", T_opcion);
  if (T_opcion) printf ("el valor de la opcion T es: %s\n", T_valor);
  printf ("opcion u %d\n", u_opcion);
  printf ("opcion X %d\n", X_opcion);
  if (X_opcion){
    printf ("el valor de la opcion X es: %s\n", X_valor);
    printf ("%3d %3d %3d %3d %3d %3d\n", 
            X_valori[0], X_valori[1], X_valori[2],
            X_valori[3], X_valori[4], X_valori[5]);
    }
  printf ("opcion y %d\n", y_opcion);
  if (y_opcion) printf ("el valor de la opcion y es: %s\n", y_valor);
  printf ("opcion z %d\n", z_opcion);
}

void misopc (int argc, char **argv)
{
  inicopc ();
  // leeOpcionesPers ();
  getoffiopc ();
  getofclopc (argc, argv);
  if (d_valori >= 20)
    printopc ();
}

