
#include "aplica.h"
#include "imag.h"
// #include "inclfont.h"
#include "inclina0.h"

/********************* rectas *********************/

void pintaRhn (tvent vent, int y, int x1, int x2, int n)
{
  int x;
  char ** pix;
  pix = vent->pix ;
  for(x=x1;x<=x2;x++)
    pix[y][x]= (char) 255*((x/n)%2);
}

void pintaRh (tvent vent, int y, int x1, int x2)
{
  pintaRhn (vent, y, x1, x2, 1);
}

void pintaRlhn (tvent vent, int y, int t, int n)
{
  pintaRhn (vent, y, 0, t, n);
}

void pintaRlh (tvent vent, int y, int t)
{
  pintaRlhn (vent, y, t, 1);
}

void pintaRvn (tvent vent, int x, int y1, int y2, int n)
{
  int y;
  char ** pix;
  pix = vent->pix ;
  for(y=y1;y<=y2;y++)
    pix[y][x]= (char) 255*((y/n)%2);
}

void pintaRv (tvent vent, int x, int y1, int y2)
{
  pintaRvn (vent, x, y1, y2, 1);
}

/* recta inclinada ~ vertical, dada la inclinacion */
void pintaRivn (tvent vent, int x1, int incl, int y1, int y2, int n)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  for(y=y1;y<=y2;y++){
    x = x1 + inclf_desvx(incl, y-y1);
    pix[y][x]= (char) 255*((y/n)%2);
    }
}

/* recta inclinada ~ vertical, dados los puntos */
void pintaRivn2 (tvent vent, int x1, int x2, int y1, int y2, int n)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  if (y2 < y1) {
    int aux;
    aux = x1; x1 = x2; x2 = aux;
    aux = y1; y1 = y2; y2 = aux;
    }
  for(y=y1;y<=y2;y++){
    if ((x2-x1)*(y2-y1) > 0)
      x = x1 + ((x2 - x1)*(y -y1) + (y2 - y1)/2) / (y2 -y1);
    else
      x = x1 + ((x2 - x1)*(y -y1) - (y2 - y1)/2) / (y2 -y1);
    pix[y][x]= (char) 255*((y/n)%2);
    }
}

/* recta inclinada ~ horizontal, dada la inclinacion */
void pintaRihn (tvent vent, int y1, int incl, int x1, int x2, int n)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  for(x=x1;x<=x2;x++){
    y = y1 + inclf_desvx(incl, x-x1);
    pix[y][x]= (char) 255*((x/n)%2);
    }
}

/* recta inclinada ~ horizontal, dados los puntos */
void pintaRihn2 (tvent vent, int x1, int x2, int y1, int y2, int n)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  if (x2 < x1) {
    int aux;
    aux = x1; x1 = x2; x2 = aux;
    aux = y1; y1 = y2; y2 = aux;
    }
  for(x=x1;x<=x2;x++){
    if ((x2-x1)*(y2-y1) > 0)
      y = y1 + ((y2 - y1)*(x -x1) + (x2 - x1)/2) / (x2 -x1);
    else
      y = y1 + ((y2 - y1)*(x -x1) - (x2 - x1)/2) / (x2 -x1);
    pix[y][x]= (char) 255*((x/n)%2);
    }
}

/* recta inclinada ~ , dados los puntos */
void pintaRin2 (tvent vent, int x1, int x2, int y1, int y2, int n)
{
  if (abs(y2-y1) > abs(x2-x1))
    pintaRivn2 (vent, x1, x2, y1, y2, n);
  else
    pintaRihn2 (vent, x1, x2, y1, y2, n);
}

/********************* rectangulos, romboides *********************/

void pintaRectIntXy (tvent vent, int x, int y, int tx, int ty)
{
  pintaRhn (vent, y,      x, x+tx-1, 1);
  pintaRhn (vent, y+ty-1, x, x+tx-1, 2);
  pintaRvn (vent, x,      y, y+ty-1, 1);
  pintaRvn (vent, x+tx-1, y, y+ty-1, 2);
}

void pintaRectIncIncIntXy (tvent vent, int x, int y, int tx, int ty, int incl)
{
  int dxs;
  dxs = inclf_desvx(incl, ty-1);
  pintaRhn  (vent, y,      x,     x+tx-1,     1);
  pintaRhn  (vent, y+ty-1, x+dxs, x+tx-1+dxs, 2);
  pintaRivn (vent, x,      incl,  y, y+ty-1, 1);
  pintaRivn (vent, x+tx-1, incl,  y, y+ty-1, 2);
}

/* obsoleto ? */
void pintaRectIncDxIntXy (tvent vent, int x, int y, int tx, int ty, int dx)
{
  pintaRhn  (vent, y,      x,    x+tx-1,    1);
  pintaRhn  (vent, y+ty-1, x+dx, x+tx-1+dx, 2);
  pintaRivn (vent, x,      x+dx,      y, y+ty-1, 1);
  pintaRivn (vent, x+tx-1, x+tx-1+dx, y, y+ty-1, 2);
}

void pintaRectIntVent (tvent vent)
{
  int incl;
  incl = vent->incl ;
  if ((vent->tx >= 2) && (vent->ty >= 2)) {
    if (incl == 0)
      pintaRectIntXy (vent->imaBase->ven0, vent->dx, vent->dy,
                                           vent->tx, vent->ty);
    else {
      int dxs;
      dxs = inclf_desvx(incl, vent->ty -1);
      if (incl > 0)
        pintaRectIncIncIntXy (vent->imaBase->ven0, vent->dx,       vent->dy,
                                                   vent->tx - dxs, vent->ty, incl);
      else /* incl < 0 */
        pintaRectIncIncIntXy (vent->imaBase->ven0, vent->dx - dxs, vent->dy,
                                                   vent->tx + dxs, vent->ty, incl);
      }
    }
}

void pintaRectIntVentanas2 (tvvents vvents)
{
  aplicaVvents (vvents, pintaRectIntVent);
}

void pintaRectIntVentanas (lista lvint)
{
  aplicaLvents (lvint, pintaRectIntVent);
}

void pintaRectIntVentanasHojRecur (tvent vent, int n)
{
  aplicaLventsHojRecurN (vent, n, pintaRectIntVent);
}

void pintaRectIntVentanasRecur (tvent vent, int n)
{
  aplicaLventsRecurN (vent, n, pintaRectIntVent);
}

/********************* cuadricula *********************/

void cuadricula (tvent vent, int n)
{
  int x, y;
  int n2, n10;
  n2 = n * 2;
  n10 = n * 10;
  for (y=0; y < vent->ty; y +=n)
    if (y>0) {
      if ((y % n10)==0) 
        pintaRhn (vent, y, 0, vent->tx -1, 3);
      else if ((y % n2)==0)
        pintaRhn (vent, y, 0, vent->tx -1, 1);
      else {
        pintaRhn (vent, y, 0, 10, 1);
        pintaRhn (vent, y, vent->tx -11,
                           vent->tx -1, 1);
        }
      }
  for (x=0; x < vent->tx; x +=n)
    if (x>0) {
      if ((x % n10)==0)
        pintaRvn (vent, x, 0, vent->ty -1, 3);
      else if ((x % n2)==0)
        pintaRvn (vent, x, 0, vent->ty -1, 1);
      else {
        pintaRvn (vent, x, 0, 10, 1);
        pintaRvn (vent, x, vent->ty -11,
                           vent->ty -1, 1);
        }
      }
}

// gris fijo
void pintaGris (tvent vent, int gr)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  for (y=0; y < vent->ty; y++)
  for (x=0; x < vent->tx; x++) {
    pix [y][x] = gr;
    }
}

// rampa diagonal 0..255
void pintaGris2 (tvent vent)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  for (y=0; y < vent->ty; y++)
  for (x=0; x < vent->tx; x++) {
    pix [y][x] = (y+x) % 255;
    }
}

// rampa diagonal gr1..gr2
void pintaGris3 (tvent vent, int gr1, int gr2)
{
  int x, y;
  char ** pix;
  pix = vent->pix ;
  for (y=0; y < vent->ty; y++)
  for (x=0; x < vent->tx; x++) {
    pix [y][x] = ((y+x) % (gr2-gr1)) + gr1 ;
    }
}
