
#include <stdio.h>
#include <stdlib.h>

#include "aplica.h"
#include "atributos.h"
#include "base.h"
#include "config.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "imag.h"
#include "imagio.h"
#include "imagx.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "inclina.h"
#include "line.h"
#include "lista.h"
#include "lvent.h"
#include "opcns.h"
#include "pinta.h"
#include "segmen.h"
#include "segmenta.h"
#include "segmenta0.h"
#include "senial.h"
#include "tarea.h"
#include "tfd2d.h"

// #define INCLN 62
#define INCLN 40

int d_segmenta = 0; // 

// int kt=0;

//----------------------- parametrosCorte... -----------------------

void parametrosCorteHorizontal (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 7 ;
  parsCorte->anPromMax  = ktam * 2 ;
  parsCorte->anMin      = ktam * 4 ;  // 3
  parsCorte->anPromMin  = ktam * 5 ;  // 4
  parsCorte->anProm     = ktam * 4/3;  // 2
  parsCorte->nivCh      = 30 ;    // 40
  // if ( X_opcion ) {
  //   parsCorte->anMin      = X_valori * ktam ;
  //   }
  // else {
  // parsCorte->anMin      = 3 * ktam;
  // }
}

void parametrosCorteVertical (tparsSenial *parsCorte, int ktam)
{
  // printf (" = == %d\n", ktam);
//
  parsCorte->anMax      = ktam * 7 ;
//  parsCorte->anMax      = ktam *10 ;  // <<
  parsCorte->anPromMax  = ktam * 5 ;
  parsCorte->anMin      = ktam *17 ;
//  parsCorte->anPromMin  = ktam * 37 ;    // pdf
  parsCorte->anPromMin  = ktam * 7 ;
//  parsCorte->anProm     = ktam * 0 ;
  parsCorte->anProm     = ktam / 4 ; 
  parsCorte->anProm     = ktam * 0 ;
//  parsCorte->nivCh      = 9 .. 2 ; // 4
  parsCorte->nivCh      = 4 ;
////         PRUEBA chino (7+1)
////  printf("----------------ktam: %4d\n", ktam);
//  parsCorte->anMax      = ktam * 7 ;
//  parsCorte->anPromMax  = ktam * 5 ;
//  parsCorte->anMin      = ktam *17 ;
//  parsCorte->anPromMin  = ktam * 7 ;
//  parsCorte->anProm     = (ktam * 8 ) / 20 ;
//  parsCorte->nivCh      = 3 ;
////
  if (X_opcion) {
    parsCorte->anMax      = ktam * X_valori[0] ;
    parsCorte->anPromMax  = ktam * X_valori[1] ;
    parsCorte->anMin      = ktam * X_valori[2] ;
    parsCorte->anPromMin  = ktam * X_valori[3] ;
    parsCorte->anProm     = ktam * X_valori[4] ;
    parsCorte->nivCh      = X_valori[5] ;
    }
//
}

void parametrosCorteVerticalIncl (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 7 ;
  parsCorte->anPromMax  = ktam * 5 ;
  parsCorte->anMin      = ktam *17 ;
  parsCorte->anPromMin  = ktam * 7 ;
  parsCorte->anPromMin  = ktam * 37 ;     // pdf
  parsCorte->anProm     = ktam * 0 ;
//  parsCorte->nivCh      = 1 ;
  parsCorte->nivCh      = 1 ;
}

void parametrosCorteVerticalColumnas (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 100 ;
  parsCorte->anPromMax  = ktam * 100 ;
  parsCorte->anMin      = ktam * 100 ;
  parsCorte->anPromMin  = ktam * 100 ;
  parsCorte->anProm     = ktam *   1  ;
  parsCorte->nivCh      = 10 ;
}

void parametrosCorteVerticalPiedepag (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam * 100 ;
  parsCorte->anPromMax  = ktam * 100 ;
  parsCorte->anMin      = ktam * 100 ;
  parsCorte->anPromMin  = ktam * 100 ;
  parsCorte->anProm     = ktam *   2  ;
  parsCorte->nivCh      = 10 ;
}

void parametrosCorteVerticalCapitular (tparsSenial *parsCorte, int ktam)
{
  parsCorte->anMax      = ktam *  20 ;
  parsCorte->anPromMax  = ktam *  20 ;
  parsCorte->anMin      = ktam *  20 ;
  parsCorte->anPromMin  = ktam *  20 ;
  parsCorte->anProm     = ktam *   4  ;
  parsCorte->nivCh      = 35 ;
}

//----------------------- ... -----------------------

void juntaparesLineaPequeniaNormal (lista cortes)
{
  tnodol nodol;
  tsegm corte, corteSig;
  int tam, tamSig, tamHueco ;
  if (cortes->primero != cortes->ultimo){
    for (nodol = cortes->primero; (nodol != cortes->ultimo) &&
		                  (nodol != 0L); nodol = nodol->siguiente) {
      corte     = (tsegm) nodol->aitem;
      corteSig  = (tsegm) nodol->siguiente->aitem;
      tam      = tamanyoSegm (corte) ;
      tamSig   = tamanyoSegm (corteSig) ;
      tamHueco = corteSig->u0 - corte->u1 - 1 ;
      /* y 2/3 condiciones ...? (en una funcion) */
      if ( ( (tam          <= tamSig/12) &&
             (tamHueco     <= tamSig/18) &&
//	     (tam+tamHueco <= tamSig/7 ) ) ) {
	     (tam+tamHueco <= tamSig/7 ) ) ||
	   ( (tamHueco     <= tamSig/18) &&     //30
	     (tam          <= tamSig/3) ) ) {    //4
        uneasegmentoSiguiente (cortes, nodol);
	}
      }
    }
}

void ensanchaLin0 (lista cortes, int tv, int pxf, int pprop)
{
  int localt = 0;
  tnodol nodol;
  tsegm corte, corteSig, cortePrim, corteUltm;
  int tam, tamSig, tamHueco ;
  int d1, d2, dd1, dd2;
  int pxfd2, pprop2;
  int cprimu0, cultmu1;
  pxfd2 = pxf / 2;
  pprop2 = pprop * 2;
  if (cortes->primero != cortes->ultimo){
    for (nodol = cortes->primero; nodol != cortes->ultimo; nodol = nodol->siguiente) {
      corte     = (tsegm) nodol->aitem;
      corteSig  = (tsegm) nodol->siguiente->aitem;
      tam      = tamanyoSegm (corte) ;
      tamSig   = tamanyoSegm (corteSig) ;
      tamHueco = corteSig->u0 - corte->u1 - 1 ;
      /* antes: ...  = 2 + ... / 10   */
      d1 = pxf + (tam    / pprop) ;
      d2 = pxf + (tamSig / pprop) ;
      if (tamHueco >= (d1 + d2)) {
        corte->u1    += d1 ;
        corteSig->u0 -= d2 ;
        }
      else {
        dd1 = (tamHueco * d1)/(d1+d2) ;
        dd2 =  tamHueco - dd1 ;
        corte->u1    += dd1 ;
        corteSig->u0 -= dd2 ;
        }
      }
    }
  /* ensanchar por arriba la fila 0.a y por abajo la ultima (nlin-1) */
     /* falta evitar la zona girada por la correccion de inclinacion */
  cortePrim = (tsegm) cortes->primero->aitem ;
     /* antes  .. = 2 + (... / 15) */
     // sube hasta 1 , casi hasta 0, pero no bajes
  d2 = pxfd2 + (tamanyoSegm (cortePrim) / pprop2) ;
  cprimu0       = max(1,       cortePrim->u0 - d2) ;
  cortePrim->u0 = min(cprimu0, cortePrim->u0 ) ;
  /**/
  corteUltm = (tsegm) cortes->ultimo->aitem ;
     /* antes  .. = 2 + (... / 15) */
     // baja hasta tv-2 , casi hasta tv-1, pero no subas
  d1 = pxfd2 + (tamanyoSegm (corteUltm) / pprop2) ;
  cultmu1       = min(tv-2,    corteUltm->u1 + d1) ;
  corteUltm->u1 = max(cultmu1, corteUltm->u1 ) ;
  //
          if (localt || (d_valori >= 10)) printf ("ocre: ensanchaLin,\n") ;
          if (localt || (d_valori >= 30)) imprimeSegmentos (cortes);
}

void ensanchaLin (lista cortes, int tv)
{
  if (! listaVacia (cortes))
    ensanchaLin0 (cortes, tv, 4, 3);
}

void ensanchaCol (lista cortes, int tv)
{
  if (! listaVacia (cortes))
    ensanchaLin0 (cortes, tv, 8, 10);
}

void pintaCortesH (tvent vent, lista cortes)
{
  tnodol nodol;
  tsegm corte;
  for (nodol = cortes->primero; nodol != 0L;nodol = nodol->siguiente) {
    corte  = (tsegm) nodol->aitem;
    pintaRhn (vent, corte->u0, 0, vent->tx-1, 1);
    pintaRhn (vent, corte->u1, 0, vent->tx-1, 2);
    }
}

void pintaCortesV (tvent vent, lista cortes)
{
  tnodol nodol;
  tsegm corte;
  for (nodol = cortes->primero; nodol != 0L;nodol = nodol->siguiente) {
    corte  = (tsegm) nodol->aitem;
    pintaRvn (vent, corte->u0, 0, vent->ty-1, 1);
    pintaRvn (vent, corte->u1, 0, vent->ty-1, 2);
    }
}

/* para cortar Lineas y letras , los cortes son bloques */
void ventanasDeCortes (lista *nlineas, tvent vent, lista cortes,
                       void ventanaEnVentanaLargXxx(tvent *, tvent, int, int))
{
  tnodol nodol;
  lista lineas;
  int * conv;
  lineas = listaNueva ();
  for (nodol = cortes->primero; nodol != 0L; nodol = nodol->siguiente) {
    tsegm corte;
    tvent vlinea;
    corte = (tsegm) nodol->aitem;
    ventanaEnVentanaLargXxx (&vlinea, vent,
		             corte->u0,
			     tamanyoSegm (corte) );
    conv = tenerConvSobreVentana (vent);
    ponerConvenVentana (vlinea, conv);
    anyadeVentana (lineas, vlinea);
    }
  *nlineas = lineas;
}

void ventanasDeCortesVIncl (lista *nlineas, tvent vent, lista cortes, int incl)
{
  tnodol nodol;
  lista caracteres;
  int * conv;
  int dxinc, txinc;
  int dxs;
  dxs = inclf_desvx(incl, vent->ty-1);
  if (incl > 0) {
    dxinc = 0;
    txinc = dxs;
    }
  else  /* incl < 0 */
    {
    dxinc = dxs;
    txinc = -dxs;
    }
  caracteres = listaNueva ();
  for (nodol = cortes->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    int menortam ;
    tsegm corte;
    tvent vcaracter;
    corte = (tsegm) nodol->aitem;
    menortam = max(0, - corte->u0 - dxinc);
    ventanaEnVentanaLargVer (&vcaracter, vent,
                             max(0, corte->u0 + dxinc),
                             tamanyoSegm (corte) + txinc - menortam);
    conv = tenerConvSobreVentana (vent);
    ponerConvenVentana (vcaracter, conv);
    vcaracter->incl = incl ;
    anyadeVentana (caracteres, vcaracter);
    }
  *nlineas = caracteres;
}

// para bloques, quiza inclinados
void ventanasDeCortesVIncl2 (lista *nlineas, tvent vent, lista cortes, int incl)
{
  tnodol nodol;
  lista caracteres;
  int dxinc;
  // int txinc;
  int dxs;
  // int fondo;
//  int nh;
  // tdcaracHistoGr carHisGr;
  dxs = inclf_desvx(incl, vent->ty-1);
  if (incl > 0) {
    dxinc = 0;
    // txinc = dxs;
    }
  else  // incl < 0
    {
    dxinc = dxs;
    // txinc = -dxs;
    }
  // carHisGr = carhisgrDeVentana (vent);
  // fondo =  carHisGr->xblanco ;
//  printf ("ventanasDeCortesVIncl2, fondo: %4d\n", fondo);
  caracteres = listaNueva ();
  for (nodol = cortes->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    tsegm corte;
    // tvent vcaracter;
    tvent vcaracterLimpia;
    corte = (tsegm) nodol->aitem;
    // ventanaEnVentanaLargVer (&vcaracter, vent,
    //                          max (0, corte->u0 + dxinc),
    //                          tamanyoSegm (corte) + txinc);
    // ventanaLimpDeVentanaIncl (&vcaracterLimpia, vcaracter, fondo);
    ventanaEnVentanaLargVerInclLimpConMargen
	                    (&vcaracterLimpia, vent,
			     corte->u0, tamanyoSegm (corte)-dxinc, incl*vent->ty/256/256);
    ponerConvenVentana (vcaracterLimpia, vent->conv);
    vcaracterLimpia->incl = 0 ;
//  printf ("inclinacion: %5d\n", incl);
//  presentaVentana (&nh, vcaracterLimpia, "sal36e.pgm", 1); para (); exit (0);
    vcaracterLimpia->incl = incl ;
    anyadeVentana (caracteres, vcaracterLimpia);
    }
  *nlineas = caracteres;
}

// para cortar Palabras, los cortes son huecos 
void ventanasDeCortesV2 (lista *nlineas, tvent vent, lista cortes)
{
  tnodol nodol;
  lista lineas;
  tvent vpalabra;
  int finAntes, fin;
  lineas = listaNueva ();
  finAntes = -1 ;
  for (nodol = cortes->primero; nodol != (tnodol)0L ; nodol = nodol->siguiente) {
    fin = centroSegm ((tsegm) nodol->aitem);
    ventanaEnVentanaLargVer ( & vpalabra, vent,
                             finAntes+1,
			     fin - finAntes);
    ponerConvenVentana (vpalabra, vent->conv);
    anyadeVentana (lineas, vpalabra);
    finAntes = fin;
    }
  fin = vent->tx - 1 ;
  ventanaEnVentanaLargVer ( & vpalabra, vent,
                           finAntes+1,
                           fin - finAntes);
  ponerConvenVentana (vpalabra, vent->conv);
  anyadeVentana (lineas, vpalabra);
  *nlineas = lineas;
}

//----------------------- linea -----------------------

void segmentaLin (tvent vent)
{
  lista lineas;
  int hisH[MAXPIXV];
  tvectder vectder;
  int ktam;
  lista cortes;
  tparsSenial parsCorteH;
//
  histoHor2 (hisH, vent) ;
  // histoHor3 (hisH, vent, 30, 150, 55);
  // {
  // tvent ventizq;   / * ventana de la parte izquierda de la columnaP * /
  // ventanaEnVentana (&ventizq, vent, 0, 0, min(200,vent->tx), vent->ty);
  //                           / *     =     ========          <<<<< parche, mejorar * /
  // prepara (ventizq) ;
  // histoHor2 (hisH, ventizq) ;
  // }
  ktam = ktamDeVentana (vent);
  if (d_valori+d_segmenta >= 4)
    printf ("%d\n", ktam);
  if (ktam > 15)
    ktam = ktam/2;
  ktam = (ktam == -1) ? 4 : ktam ;
  ktam = (ktam ==  0) ? 4 : ktam ;
  // ktam=6;
  parametrosCorteHorizontal (& parsCorteH, ktam);
  paraCortes (&vectder, hisH, vent->ty, parsCorteH, "H") ;
  // {
  // int nh;
  // presentaHisVectder (&nh, hisH, vectder, "sal17h.dat", "sal17h.gpt");
  // }
  cortaLin (&cortes, vectder, vent->ty);
  vectderFree (vectder);
  // juntaparesLineaPequeniaNormal (cortes);
  // imprimeSegmentos (cortes);
  // exit (0);
  if (! listaVacia(cortes))
    ensanchaLin (cortes, vent->ty);
  // juntaparesLineaPequeniaNormal (cortes);
  // imprimeSegmentos (cortes);
  // pintaCortesH (vent, cortes);
  ventanasDeCortes (&lineas, vent, cortes, ventanaEnVentanaLargHor);
  liberaItemsNodosYlista (cortes);
  vent->lvint = lineas;
  if (d_valori >= 10)
    printf ("ocre: segmentaLin,\n") ;
}

//----------------------- auxiliares  -----------------------


Boolean llegaGrisIncl (tvent vent, int y, int nivAj)
{
  int x; 
  int tx, ty;
  int x0, x1;
  Boolean llg;
  int xp, xu;
  int incl;
  char ** pix;
  tx  = vent->tx;
  ty  = vent->ty;
  incl = vent->incl;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  pix = vent->pix;
  x0 = xp + inclf_desvx(incl, y);
  x1 = xu + inclf_desvx(incl, y);
  llg = FALSE ;
  for (x=x0; x <= x1; x++)
    if ((pix[y][x] & 0xFF) < nivAj)
      llg = TRUE ;
  return llg ;
}

Boolean llegaGrisRec (tvent vent, int y, int nivAj)
{
  int x;  
  int tx;
  Boolean llg;
  char ** pix;
  llg = FALSE ; 
  tx  = vent->tx;
  pix = vent->pix;
  for (x=0; x<tx; x++)
    if ((pix[y][x] & 0xFF) < nivAj)
      llg = TRUE ;
  return llg ;
}

Boolean llegaGris (tvent vent, int y, int nivAj)
{
  if (vent->incl != 0)
    return llegaGrisIncl (vent, y, nivAj) ;
  else
    return llegaGrisRec  (vent, y, nivAj) ;
}

Boolean llegaGrisVIncl (tvent vent, int x, int nivAj)
{
  int xi, y; 
  int ty;
  Boolean llg;
  int incl;
  char ** pix;
  ty  = vent->ty;
  incl = vent->incl;
  pix = vent->pix;
  llg = FALSE ;
  for (y=0; y < ty; y++){
    xi = x + inclf_desvx(incl,y);
    if ((pix[y][xi] & 0xFF) < nivAj)
      llg = TRUE ;
    }
  return llg ;
}

Boolean llegaGrisVRec (tvent vent, int x, int nivAj)
{
  int y;  
  int ty;
  Boolean llg;
  char ** pix;
  llg = FALSE ; 
  ty  = vent->ty;
  pix = vent->pix;
  for (y=0; y<ty; y++)
    if ((pix[y][x] & 0xFF) < nivAj)
      llg = TRUE ;
  return llg ;
}

Boolean llegaGrisVs (tvent vent, int x, int nivAj)
{
  if (vent->incl != 0)
    return llegaGrisVIncl (vent, x, nivAj) ;
  else
    return llegaGrisVRec  (vent, x, nivAj) ;
}

//----------------------- caracter -----------------------

void ajusteVCar1 (int *ny0, int *ny1, tvent vent, int nivAj)
{
  int y0, y1, ty;
  ty =  vent->ty;
  y0  = 0;
  /* desplaza hacia abajo el limite superior del caracter */
  while ((y0 < ty) && ! llegaGris (vent, y0, nivAj))
    y0 ++ ; 
  y1 = ty - 1;
  /* desplaza hacia arriba el limite inferior del caracter */
  while ((y1 >y0) && ! llegaGris (vent, y1, nivAj)) {
    y1 -- ;
    }
  *ny0 = y0;
  *ny1 = y1;
  if (d_valori >= 40)
    printf ("ocre: ajustaVCar1\n") ;
}

Boolean singrisNorte (int *ysg, int *ysg2, tvent vent, int nivAj)
{
  int y, ty;
  Boolean singr;
  Boolean singr2;
  y = 0;
  singr = FALSE;
  ty =  vent->ty;
  while ((y < ty) && ! singr) {
    singr = ! llegaGris (vent, y, nivAj) ;
    y ++;
    }
  *ysg = y;
  if (singr) {
    singr2 = TRUE;
    while ((y < ty) && singr2) {
      singr2 = ! llegaGris (vent, y, nivAj) ;
      y ++;
      }
    *ysg2 = y;
    }
  return singr;
}

Boolean singrisSur (int *ysg, int *ysg2, tvent vent, int nivAj)
{
  int y;
  Boolean singr;
  Boolean singr2;
  y = vent->ty - 1;
  singr = FALSE;
  while ((y >= 0) && ! singr) {
    singr = ! llegaGris (vent, y, nivAj) ;
    y --;
    }
  *ysg = y;
  if (singr) {
    singr2 = TRUE;
    while ((y >= 0) && singr2) {
      singr2 = ! llegaGris (vent, y, nivAj) ;
      y --;
      }
    *ysg2 = y;
    }
  return singr;
}

int ponNivAj (tvent vent)
{
  int porcNeg = 41 ;                  // 61 antes ?
  tdcaracHistoGr carHisGr;
  carHisGr = carhisgrDeVentana (vent);
  return  (carHisGr->xnegro  * porcNeg +
           carHisGr->xblanco * (100 - porcNeg) ) / 100;
}

/* atentos al cambio del parametro cuarto: y1 */
void ventanaEnVentanaLargVerIncl (tvent *venti, tvent vent, int x0, int x1)
{
  /*         xp    x0 x1   xu
          +---++---+--+-----+ 0
          |  / :  /  /:    /|
          + /  : /  / :   / |
          |/   :/  /  :  /  |
          +----+--+---+-+---+ y
          x0-xp         xu-x1
          ------- tx --------
  */
      
  int tx, ty, incl;
  int xp, xu;
  int dx, txn;
  incl = vent->incl;
  tx   = vent->tx;
  ty   = vent->ty;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  dx   = x0 - xp;
  txn  = tx - dx - (xu - x1);
  // ventanaEnVentana (venti, vent, dx, 0, txn, ty) ;
  // ventanaDeVentana (venti, vent, dx, 0, txn, ty) ;
  ventanaDeVentanaCabeMen (venti, vent, dx, 0, txn, ty) ;
}

/* atentos al cambio del parametro cuarto: y1 */
void ventanaEnVentanaLargHorIncl (tvent *venti, tvent vent, int y0, int y1)
{
  /*      +-----+-----+ 0
          | x00/  x10/|
          +---+-----+-+ y0
          |  /     /  |
          +-+-----+---+ y1
          |/x01  /x11 |
          +-----+-----+
          0 |x0   x1|
  */
      
  int tx, ty, incl;
  int xp, xu;
  int x00, x01, x10, x11;
  int x0, x1;
  incl = vent->incl;
  tx   = vent->tx;
  ty   = vent->ty;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  x00 = xp + inclf_desvx(incl, y0);
  x01 = xp + inclf_desvx(incl, y1);
  x10 = xu + inclf_desvx(incl, y0);
  x11 = xu + inclf_desvx(incl, y1);
  x0 = max (0,    min (x00, x01)) ;
  x1 = min (tx-1, max (x10, x11)) ;
  ventanaEnVentana (venti, vent, x0, y0, x1 - x0 + 1, y1 - y0 +1) ;
}

void ajustaVcaracteres (lista ncaracteres)
{
  tnodol nodol;
  int y0, y1;
  int nivAj;
  tvent vent, venti;
  if (listaVacia(ncaracteres))
    return ;
  nivAj = ponNivAj ( (tvent) ncaracteres->primero->aitem );
  for (nodol = ncaracteres->primero; nodol != (tnodol)0L; nodol = nodol->siguiente){
    vent = (tvent) nodol->aitem;
    ajusteVCar1 (&y0, &y1, vent, nivAj);
    if (vent->incl == 0) {
      ventanaEnVentanaLargHor (&venti, vent, y0, y1-y0+1);
      }
    else /* vent->incl != 0 */
      {
      ventanaEnVentanaLargHorIncl (&venti, vent, y0, y1);
      venti->incl = vent->incl ;
      }
    ponerConvenVentana (venti, vent->conv);
    nodol->aitem = venti;
    }
}

//----------------------- caracteres -----------------------

void vectderDeHisto2 (tvectder *vectder, int *his, tvent vent, int ventt, char *hv, int nivmas)
{
  int ktam;
  tparsSenial parsCorteHV;
  ktam = ktamDeVentana (vent);
  ktam = (ktam == -1) ? 4 : ktam ;
  ktam = (ktam ==  0) ? 4 : ktam ;
  // printf ("ktam:%4d\n", ktam);   // 
  if (hv[0] == 'V') {
    if (vent->incl == 0)
      parametrosCorteVertical (& parsCorteHV, ktam);
      // parametrosCorteVertical (& parsCorteHV, ktam);
    else
      parametrosCorteVerticalIncl (& parsCorteHV, ktam);
    }
  else if (hv[0] == 'H')
    parametrosCorteHorizontal (& parsCorteHV, ktam);
  else if (hv[0] == 'C')
    parametrosCorteVerticalColumnas (& parsCorteHV, ktam);
  else if (hv[0] == 'P')
    parametrosCorteVerticalCapitular (& parsCorteHV, ktam);
  else //  .. == 't'
    parametrosCorteVerticalPiedepag (& parsCorteHV, ktam);
//         PRUEBA chino  (1)
//  printf("2----------------ktam: %4d\n", ktam);
  parsCorteHV.nivCh += nivmas ;
  paraCortes (vectder, his, ventt, parsCorteHV, hv) ;
}

void vectderDeHisto (tvectder *vectder, int *his, tvent vent, int ventt, char *hv)
{
  vectderDeHisto2 (vectder, his, vent, ventt, hv, 0);
}

void segmentaCarLin (tvent vent)
{
  int hisV[MAXPIXH];
  tvectder vectder;
  lista cortes;
  lista caracteres;
  histoVer2 (hisV, vent) ;
  vectderDeHisto (&vectder, hisV, vent, vent->tx, "V"); 
  cortaLin (&cortes, vectder, vent->tx);
  vectderFree (vectder);
//  pintaCortesV (vent, cortes);
  ventanasDeCortes (&caracteres, vent, cortes, ventanaEnVentanaLargVer);
  liberaItemsNodosYlista (cortes);
  ajustaVcaracteres (caracteres) ;
  vent->lvint  = caracteres ;
  if (d_valori >= 10)
    printf ("ocre: segmentaCarLin\n") ;
}

void segmentaCarLinIncl (tvent vent)
{
  int localt = 0;
  int hisV[MAXPIXH];
  tvectder vectder;
  lista cortes;
  lista caracteres;
  int incl = -INCLN*256 ;                                      //
  histoVer3Incl (hisV, vent, incl) ;                        //
  vectderDeHisto (&vectder, hisV, vent, vent->tx, "V"); 
  cortaLin (&cortes, vectder, vent->tx);
  vectderFree (vectder);
  // imprimeSegmentos (cortes);
  // pintaCortesV (vent, cortes);
  ventanasDeCortesVIncl (&caracteres, vent, cortes, incl);  //
  liberaItemsNodosYlista (cortes);
  ajustaVcaracteres (caracteres) ;
  vent->lvint = caracteres;
          if (localt || (d_valori >= 10)) printf ("ocre: segmentaCarLinIncl\n") ;
}

int K1 = 0;

Boolean rectaYnoCursiva (tvent ventpal)
{
  int inclInterm = -42*256; // original
  K1++;
  if (t_valori == 0)
    return  TRUE;
  if (t_valori == 1)
    return  FALSE ;
  /* t_valori == 2 */
  if ( ventpal->tx > (ventpal->ty * abs(inclInterm)/(256*256)) ) {
    // printf ("recta y no cursiva.incVcuad: %5d\n", calculaInclinacionVCuad(ventpal) );
    return calculaInclinacionVCuad(ventpal) > -30*256;  // 7580
    // 2002-03-11 
    // return sumaAnchoRayasBlanLarIncl(ventpal,         0) >=
    //        sumaAnchoRayasBlanLarIncl(ventpal,inclInterm)  ;
    }
  else
    return TRUE ;
}

Boolean ventanasUnidas (tvent ventcar, tvent ventcar2)
{
  int dxn, txn, dyn, tyn;
  int y;
  int nivAj;
  tvent ventn;
  nivAj = (ponNivAj (ventcar ) + ponNivAj (ventcar )) /2;
  dxn = max(ventcar->dx,ventcar2->dx) ;
  txn = min(ventcar->dx+ventcar->tx,ventcar->dx+ventcar->tx) - dxn ;
  dyn = ventcar->dy+ventcar->ty;
  tyn = ventcar2->dy - dyn;
  ventanaDeVentana (&ventn, ventcar->imaBase->ven0, dxn, dyn, txn, tyn);
  // printf ("ventanas unidas: dxn %4d dyn %4d txn %4d tyn %4d\n", dxn, dyn, txn, tyn);
  for (y=0; y<tyn; y++) {
    if (! llegaGrisRec (ventn,  y, nivAj))
      return FALSE;
    }
  return TRUE;
}

//  static int seTocan = 0;

// hay una version 2011-03? que incluye intento de leer 'mayusculas capitulares'
void segmentaCarRepaso (tvent vent)
{
  tnodol nodollin, nodolpal, nodolcar, nodolpal2, nodolcar2;
  tvent ventlin, ventlinsig, ventpal, ventpal2, ventcar, ventcar2;
  lista lvensur;
  for (nodollin = vent->lvint->primero; nodollin->siguiente != 0L;
                                        nodollin = nodollin->siguiente) {
    ventlin    = (tvent) nodollin->aitem ;
    ventlinsig = (tvent) nodollin->siguiente->aitem ;
    for (nodolpal = ventlin->lvint->primero; nodolpal != 0L; nodolpal = nodolpal->siguiente) {
      ventpal = (tvent) nodolpal->aitem ;
      for (nodolcar = ventpal->lvint->primero; nodolcar != 0L; nodolcar = nodolcar->siguiente) {
        ventcar = (tvent) nodolcar->aitem ;
	lvensur = listaNueva ();
        for (nodolpal2 = ventlinsig->lvint->primero; nodolpal2 != 0L;
	                                             nodolpal2 = nodolpal2->siguiente) {
          ventpal2 = (tvent) nodolpal2->aitem ;
          for (nodolcar2 = ventpal2->lvint->primero; nodolcar2 != 0L;
	                                             nodolcar2 = nodolcar2->siguiente) {
            ventcar2 = (tvent) nodolcar2->aitem ;
	    if (ventanaAlsur (ventcar2, ventcar))
	      if ( ventcar2->dy == (ventcar->dy + ventcar->ty) ) { // se tocan
	        aniadeafinlista (lvensur, (tpgen) ventcar2);
	        }
	    }
	  }
	// usa lvensur;
	if (longLista (lvensur)>0) {
          int nivAjn, nivAjs;
	  int ysgn, ysgs;
	  int grisNor, grisSur;
	  int ysgn2, ysgs2;
	  int grisNor2, grisSur2;
	  Boolean claroNor, claroSur;
	  tvent ventsur1;
          nivAjn = ponNivAj (ventcar );
	  claroNor = singrisSur (&ysgs, &ysgs2, ventcar, nivAjn);
	  ventsur1 = (tvent) lvensur->primero->aitem;
          nivAjs = ponNivAj ( ventsur1 );
	  claroSur = singrisNorte (&ysgn, &ysgn2, ventsur1, nivAjs);
	  grisNor = ventcar->ty - ysgs - 2;
	  grisSur = ysgn - 1;
/** /
	  printf ("== longlis:%3d vn->ty:%3d, ysgs:%3d, vs->ty:%3d, ysgn:%3d, vs->dx:%3d, vs->dy:%3d\n",
	              longLista (lvensur), ventcar->ty, ysgs, ventsur1->ty, ysgn, ventsur1->dx, ventsur1->dy);
	  printf ("== longlis:%3d vn->ty:%3d, ysgs2:%3d, vs->ty:%3d, ysgn2:%3d, vs->dx:%3d, vs->dy:%3d\n",
	              longLista (lvensur), ventcar->ty, ysgs2, ventsur1->ty, ysgn2, ventsur1->dx, ventsur1->dy);
	  seTocan ++;
	  pintaRectIntVent(ventcar);
	  pintaRectIntVent(ventsur1);
	  if (seTocan == 1) {
	    int nh;
	    presentaVentana (&nh, ventcar->imaBase->ven0, "salSeg851.pgm", 1);
	    para ();
	    }
/ **/
          // reajusteVertVentcars (ventcar, ventsur1);
	  if ((grisNor*2) >= (grisSur*3)) {
	    // ajustaVentanasBajando  (ventcar,ventsur1, grisSur);
	    ventanaCreceporelSur   (ventcar,   grisSur);
	    ventanaCreceporelNorte (ventsur1, -grisSur);
	    }
	  else if ((grisSur*2) >= (grisNor*3)) {
	    // ajustaVentanasSubiendo (ventcar, ventsur1, grisNor);
	    ventanaCreceporelSur   (ventcar,  -grisNor);
	    ventanaCreceporelNorte (ventsur1,  grisNor);
	    }
	  else {     // 'mancha' a medias del corte -> mirar 'claros'
	    if (claroNor && claroSur) {
	      grisNor2 = ventcar->ty - ysgs2 - 2;
	      grisSur2 = ysgn2 - 1;
	      if ((grisNor2*2) >= (grisSur2*3)) {
	        // ajustaVentanasSubiendo (ventcar, ventsur1, grisNor);
	        ventanaCreceporelSur   (ventcar,  -grisNor);
	        ventanaCreceporelNorte (ventsur1,  grisNor);
	        }
	      else if ((grisSur2*2) >= (grisNor2*3)) {
	        // ajustaVentanasBajando  (ventcar,ventsur1, grisSur);
	        ventanaCreceporelSur   (ventcar,   grisSur);
	        ventanaCreceporelNorte (ventsur1, -grisSur);
	        }
	      }
	    }
	  }
	liberaNodosYlista (lvensur);
	}
      }
    }
}

void segmentaCar (tvent vent)
{
  tnodol nodollin, nodolpal;
  tvent ventlin;
  tvent ventpal ;
/*
    ventlin = vent->listaVint->ventanas[0] ;
    printf ("tamY ventana %4d\n", ventlin->ty);
    {
    int j;
    for (j=0; j<5; j++) {
      ventpal = ventlin->listaVint->ventanas[j] ;
      printf ("inclinacion: %4d\n", calculaInclinacionV(ventpal));
      printf ("sumaAnchoRBLI: %4d\n", sumaAnchoRayasBlanLarIncl(ventpal,  0));
      printf ("sumaAnchoRBLI: %4d\n", sumaAnchoRayasBlanLarIncl(ventpal,-42));
      }
    }
    exit (0);
 */
  if (longLista (vent->lvint) == 0)
    return ;
  for (nodollin = vent->lvint->primero; nodollin != 0L; nodollin = nodollin->siguiente) {
    ventlin = (tvent) nodollin->aitem ;
    for (nodolpal = ventlin->lvint->primero; nodolpal != 0L; nodolpal = nodolpal->siguiente) {
      ventpal = (tvent) nodolpal->aitem ;
      /*
      ventpal->caracIncl[0] = calculaInclinacionV(ventpal) ;
      ventpal->caracIncl[1] = calculaInclinacionVCuad(ventpal) ;
      ventpal->caracIncl[2] = sumaAnchoRayasBlanLarIncl(ventpal,  0);
      ventpal->caracIncl[3] = sumaAnchoRayasBlanLarIncl(ventpal,-21*256);
      ventpal->caracIncl[4] = sumaAnchoRayasBlanLarIncl(ventpal,-42*256);
      ventpal->caracIncl[5] = sumaAnchoRayasBlanLarIncl(ventpal,-62*256);
      / *
      */
      // if (rectaYnoCursiva (ventpal)) {
      if (ventpal->incl == 0) {
        segmentaCarLin (ventpal);
        }
      else {
        segmentaCarLinIncl (ventpal);
        // describeVentanas (ventpal, 1);
        }
      }
    }
  segmentaCarRepaso (vent);
  if (d_valori >= 10)
    printf ("ocre: segmentaCar\n") ;
}

void deglifoLineaDx_y_ventLin (int *dx, tvent *vLin, tglifo glifo)
{
  tvent ventLin;
  int dxima;
  /*
  tglifo glifolin;
  for (glifolin = glifo; glifolin->tipo != glifCompLin;
	       glifolin = glifolin->glifBase);
  ventLin  = glifolin->venDeGlifo;
  */
  dxima = 0;
  for (ventLin = glifo->venDeGlifo;
       // ventLin->glifoDeVen == 0L || ((tglifo)ventLin->glifoDeVen)->tipo != glifCompLin;
       ventLin->GLifoDeVen == 0L || GLIfoDeVen(ventLin)->tipo != glifCompLin;
       ventLin = ventLin->venBase) {
    // describeVentana (ventLin);
    if (ventLin == ventLin->venBase) {
      // escribeVentana (ventLin, "sal26reseg.pgm");
      printf ("resegmentaCar, anomalia\n");
      if (ventLin->imaBase == 0L)
         printf ("resegmentaCar, Anomalia\n");
      ventLin = ventLin->imaBase->venOrig;
      dxima += ventLin->dx;
      }
    }
  * dx   = dxima;
  * vLin = ventLin;
}

void resegmentaCar0 (tvvents *nvvents,
		tvent ventLin, tvent ventCars, int delx)
{
  int hisV[MAXPIXH];
  tvectder vectder, vectder2;
  lista cortes;
  lista caracteres;
  histoVer2 (hisV, ventLin) ;
  vectderDeHisto2 (&vectder, hisV, ventLin, ventLin->tx, "V", 12);   //
  vectder2 = dervectder (vectder, delx, ventCars->tx);               //
  cortaLin (&cortes, vectder2, ventCars->tx);
  vectderFree (vectder);
  vectderFree (vectder2);
//  pintaCortesV (vent, cortes);
  ventanasDeCortes (&caracteres, ventCars, cortes, ventanaEnVentanaLargVer);
  liberaItemsNodosYlista (cortes);
  ajustaVcaracteres (caracteres) ;
  ventCars->lvint  = caracteres ;
  *nvvents = vventDeLista (caracteres);
}

void resegmentaCar0Incl (tvvents *nvvents,
		tvent ventLin, tvent ventCars, int delx)
{
  int hisV[MAXPIXH];
  tvectder vectder, vectder2;
  lista cortes;
  lista caracteres;
  int incl;                                                            //
  incl = ventCars->incl;                                               //
//-  histoVer2 (hisV, ventLin) ;
  histoVer3Incl (hisV, ventLin, incl) ;                                //
  vectderDeHisto2 (&vectder, hisV, ventLin, ventLin->tx, "V", 12);   //
  vectder2 = dervectder (vectder, delx, ventCars->tx);               //
  cortaLin (&cortes, vectder2, ventCars->tx);
  vectderFree (vectder);
  vectderFree (vectder2);
//  pintaCortesV (vent, cortes);
//  ventanasDeCortes (&caracteres, ventCars, cortes, ventanaEnVentanaLargVer);
  ventanasDeCortesVIncl (&caracteres, ventCars, cortes, incl);         //
  liberaItemsNodosYlista (cortes);
  ajustaVcaracteres (caracteres) ;
  ventCars->lvint  = caracteres ;
  *nvvents = vventDeLista (caracteres);
}

//   este procedimiento pega mas en otro fichero/modulo como segmenta(2/3).c 
void resegmentaCar (tvvents *nvvents, tglifo glifo)
{
  int dxima;
  tvent ventLin;
  tvent ventCars;
  int delx;
  deglifoLineaDx_y_ventLin (&dxima, &ventLin, glifo);
  ventCars = glifo->venDeGlifo;
  delx = ventCars->dx - (ventLin->dx - dxima) ;
  if (ventCars->incl == 0)
    resegmentaCar0 (nvvents, ventLin, ventCars, delx);
  else
    resegmentaCar0Incl (nvvents, ventLin, ventCars, delx);
  if (d_valori >= 10)
    printf ("ocre: resegmentaCar\n") ;
}
 
//----------------------- palabras -----------------------

      //                                                       PENDIENTE
      // x0 = 0 -->  xp
      // x1 = tx-1  -->  xu
void ajusteHPal1 (int *nx0, int *nx1, tvent vent, int nivAj)
{
  int x0, x1, tx, ty, incl, xp, xu;
  tx =  vent->tx;
  ty =  vent->ty;
  incl =  vent->incl;
  pon_vprim_vult (incl, ty, tx, &xp, &xu);
  x0  = xp;
  /* desplaza hacia derecha el limite izquierdo de la palabra */
  while ((x0 < xu) && ! llegaGrisVs (vent, x0, nivAj))
    x0 ++ ; 
  x1 = xu;
  /* desplaza hacia izquierda el limite derecho de la palabra */
  while ((x1 > x0) && ! llegaGrisVs (vent, x1, nivAj)) {
    x1 -- ;
    }
  *nx0 = x0;
  *nx1 = x1;
  if (d_valori >= 40)
    printf ("ocre: ajustaHPal1\n") ;
}

void ajustaHpalabra (tvent *nventi, tvent vent, int nivAj, int marg)
{
  int x0, x1;
  int x0m, t0m, x1m;
  // int xp, xu;
  int despinc;
  int despincp;
  int dx, txg;
  tvent venti, venti2;
  if (vent->incl == 0) {
    ajusteHPal1 (&x0, &x1, vent, nivAj);
    x0m = max(0, x0 -marg);
    t0m = min(x1-x0+1 +marg*2, vent->tx - x0m);
    ventanaEnVentanaLargVer (&venti, vent, x0m, t0m);
    }
  else /* vent->incl != 0 */
    {
    despinc = -(vent->ty * vent->incl)/(65576);
    despincp = -(1 * vent->ty * vent->incl)/(2*65576);
    dx  = vent->dx;
    txg = vent->imaBase->ven0->tx;
    // pon_vprim_vultR (vent->incl, vent->ty, vent->tx, &xp, &xu);
    //  printf ("xp:%4d xu:%4d\n", xp, xu);
    x0m = max(-dx+despinc, -marg+despinc-despincp);
    x1m = min(vent->tx+marg+despincp, txg-dx-1);
    ventanaEnVentanaLargVerIncl (&venti2, vent, x0m, x1m);  // cuidado campo ultim
    venti2->incl = vent->incl ;
    ajusteHPal1 (&x0, &x1, venti2, nivAj);
    ventanaEnVentanaLargVerIncl (&venti, venti2, x0, x1);  // cuidado campo ultim
    venti->incl = vent->incl ;
    }
  ponerConvenVentana (venti, vent->conv);
  *nventi = venti;
}

void ajustaHpalabras (lista palabras, int marg)
{
  tnodol nodol;
  int nivAj;
  tvent vent, venti;
  if (listaVacia(palabras))
    return ;
  nivAj = ponNivAj ( (tvent) palabras->primero->aitem );
  for (nodol = palabras->primero;
       nodol != (tnodol)0L; nodol = nodol->siguiente){
    vent = (tvent) nodol->aitem;
//-------
    if (rectaYnoCursiva (vent)) {
      vent->incl = 0;
      }
    else {
      vent->incl = -INCLN*256;
      // printf ("ocre: ajustaHpalabras cursiva\n") ;
      // describeVentana (vent); //
      }
//-------
    ajustaHpalabra (&venti, vent, nivAj, marg);
    nodol->aitem = venti;
    }
}

void cortesEnLinea (lista *ncortes, tvent ventlin)
{
  int hisV[MAXPIXH];
  tvectder vectder;
  lista blosr, blosi ; /* de bloques */
  int incl = -INCLN*256 ;
/**/
  histoVer2 (hisV, ventlin) ;
  vectderDeHisto (&vectder, hisV, ventlin, ventlin->tx, "V"); 
  cortaLin (&blosr, vectder, ventlin->tx);
  vectderFree (vectder);
/** /
  printf ("\n\n");
  describeVentana (ventlin);
  printf ("-0\n");
  imprimeHuecos (blosr);
/ **/
  histoVer3Incl (hisV, ventlin, incl) ;
  vectderDeHisto (&vectder, hisV, ventlin, ventlin->tx, "V"); 
  cortaLin (&blosi, vectder, ventlin->tx);
  vectderFree (vectder);
  desplazaSegmentos (blosi, -INCLN * ventlin->ty / 512);
/** /
  printf ("-1\n");
  imprimeHuecos (blosi);
/ **/
  huecosInterseccionSegmentos (ncortes, blosr, blosi, ventlin->ty);
  liberaItemsNodosYlista (blosr);
  liberaItemsNodosYlista (blosi);
/** /
  printf ("-2\n");
  imprimeSegmentos (*ncortes);
/ **/
}

void segmentaPal (tvent vent)
{
  tnodol nodol;
  for (nodol = vent->lvint->primero; nodol != 0L; nodol = nodol->siguiente) {
    tvent ventlin;
    lista cortes ;
    lista palabras;
    ventlin = (tvent) nodol->aitem ;
    cortesEnLinea (&cortes, ventlin);
    // if (kt>444) {
    //   printf ("ocre.segmenta.segmentapal\n") ;
    //   describeVentana (ventlin);
    //   imprimeSegmentos (cortes);
    //   }
    ventanasDeCortesV2 (&palabras, ventlin, cortes);
    liberaItemsNodosYlista (cortes);
    ajustaHpalabras (palabras, 1);   //
    ventlin->lvint = palabras;
    }
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaPal\n") ;
}

//----------------------- columnaParrafo -----------------------

void segmentaColumnaP (tvent vent)
{
  // int nh;
  if (d_valori >= 8)
    printf ("segmentaColumnaP\n");
  prepara (vent);
  segmentaLin (vent);
  segmentaPal (vent);
  segmentaCar (vent);
  // pintaRectIntVentanasRecur (vent, 3);
  // presentaVentana (&nh, vent, "sal38d.pgm", 2);
  // para ();
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaColumnaP\n") ;
}

void segmentaCarchin (tvent vent)
{
  tnodol nodol;
  for (nodol = vent->lvint->primero; nodol != 0L; nodol = nodol->siguiente) {
    tvent ventlin;
    lista cortes ;
    lista caracteres;
    ventlin = (tvent) nodol->aitem ;
    cortesEnLinea (&cortes, ventlin);
    ventanasDeCortesV2 (&caracteres, ventlin, cortes);
    liberaItemsNodosYlista (cortes);
    ventlin->lvint = caracteres;
    }
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaCarchin\n") ;
}

void segmentaColumnaPchin (tvent vent)
{
  // int nh;
  prepara (vent);
  segmentaLin (vent);
  // segmentaPal (vent);
  segmentaCarchin (vent);
  // pintaRectIntVentanasRecur (vent, 3);
  // presentaVentana (&nh, vent, "sal38d.pgm", 2);
  // para ();
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaColumnaPchin\n") ;
}

//----------------------- columnas/parrafos -----------------------

void repasaCortesCols (lista cortes, int tx)
{
// chapuza      <<<<<<<<<<<
//  eliminaUltimoSegm (cortes);
  ensanchaCol (cortes, tx);
}

void repasaCortesPiedepag (lista cortes, int tx)
{
  ensanchaCol (cortes, tx);
}

//   .... bb .... bb ....
void segmentaCols (tvent vent, int *hisV, int incl)
{
  int localt = 0;
  tvectder vectder;
  lista cortes;
  lista cortes_r;
  lista cortes_r2;
  lista columnas;
  vectderDeHisto (&vectder, hisV, vent, vent->tx, "C");
  // int nh;
  // presentaHisVectder (&nh, hisV, vectder, "sal26v.dat", "sal26v.gpt");
  cortaLin (&cortes, vectder, vent->tx);
  // imprimeSegmentos (cortes); printf ("\n");
         if (localt)  {imprimeSegmentos (cortes); printf ("\n");}
  // AQUI
  // cortes_r = eliminaHuecosMenores (cortes, 27);  // 27: 11..65  PENdiente ajustar
  cortes_r2 = eliminaHuecosMenores (cortes, 27);  // 27: 11..65  PENdiente ajustar
  cortes_r = reuneSegmentosMenores (cortes_r2, 300);   // quiza ...
         if (localt)  {imprimeSegmentos (cortes_r); printf ("\n");}
  repasaCortesCols (cortes_r, vent->tx);
  // imprimeSegmentos (cortes_r); printf ("\n");
  ventanasDeCortesVIncl2 (&columnas, vent, cortes_r, incl);
  // printf ("numero de ventanas: %3d\n", longLista (columnas));
  vent->lvint = columnas;
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaCols\n") ;
}

// EN_OBRAS: 2017/2/9 ...
//   ===
void segmentaPsjs (tvent vent, int *hisH, int incl)
{
  int localt = 0;
  tvectder vectder;
  lista cortes;
  lista cortes_r;
  lista paisajes;
                        // en_obras: quiza camb. 
  vectderDeHisto (&vectder, hisH, vent, vent->ty, "C");
  // int nh;
  // presentaHisVectder (&nh, hisH, vectder, "sal26v.dat", "sal26v.gpt");
  cortaLin (&cortes, vectder, vent->ty);
         if (localt)  {imprimeSegmentos (cortes); printf ("\n");}
  cortes_r = eliminaHuecosMenores (cortes, 22);  // 28: 19...25..41  PENDiente ajustar
         if (localt)  {imprimeSegmentos (cortes_r); printf ("\n");}
                        // en_obras: quiza luego NO se repasa
  repasaCortesCols (cortes_r, vent->ty);   // a ello
  // imprimeSegmentos (cortes); printf ("\n");
                        // en_obras: empiezo con corte sencillo
  // ventanasDeCortesHIncl2 (&paisajes, vent, cortes, incl);
  // ventanasDeCortesHIncl (&paisajes, vent, cortes, incl);
  ventanasDeCortes (&paisajes, vent, cortes_r, ventanaEnVentanaLargHor);
  //
  // printf ("numero de ventanas: %3d\n", longLista (paisajes));
  vent->lvint = paisajes;
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaPsjs\n") ;
}

void segmentaPiedepag (tvent vent, int *hisH, int incl)
{
  tvectder vectder;
  lista cortes;
  lista tirash;
  // tvent venlimpia;
  vectderDeHisto (&vectder, hisH, vent, vent->ty, "t");
// { int nh; presentaHisVectder (&nh, hisH, vectder, "sal26v.dat", "sal26v.gpt"); para (); }
  cortaLin (&cortes, vectder, vent->ty);
//  printf ("presentaHisVectder.imprimeSegmentos (cortes);\n");
//  imprimeSegmentos (cortes);
  repasaCortesPiedepag (cortes, vent->ty);
//  ventanasDeCortesVIncl2 (&tirash, vent, cortes, incl);
  ventanasDeCortes (&tirash, vent, cortes, ventanaEnVentanaLargHor);
     // cambiar cuando la inclinacion superponga ...
  vent->lvint = tirash;
  if (d_valori >= 10)
    printf ("ocre.segmenta.segmentaPiedepag\n") ;
}

//----------------------- lineas base -----------------------

void lineasBase (int *base, int *alturax, tvent vent)
{
  int hisH[MAXPIXV];
  int pendientes[MAXPIXV];
  int pendientesMenoshish[MAXPIXV];
  int ty;
  int base1, alturax1;
  int i;
  // int maxHish;
  histoHor2 (hisH, vent) ;
  ty = vent->ty;
  aplicaV (hisH, pendientes, ty, 1, pend) ; 
  /** /
  printf ("--------------- ty:%4d dy:%4d\n", ty, vent->dy);
  imprimeVecI (pendientes, ty);
  / **/
  base1    = posmaxv (pendientes, ty);
  alturax1 = posminv (pendientes, ty);
//  minPendiente = pendientes [alturax1];
  // maxHish      = maxv (hisH, ty);
  for (i=0; i<ty; i++)
    pendientesMenoshish[i] = pendientes[i] + hisH[i] / 6 ;
    // pendientesMenoshish[i] = pendientes[i] + abs(maxHish/2 -hisH[i]) / 3 ;
  alturax1 = posminv (pendientesMenoshish, ty);
  // alturax1 = base1 - 32;
  if ( (alturax1 > base1) || ((base1 - alturax1) < ty/3) )
    {
    /*
    static int nl = 0;
    nl ++;
    printf("ocre.segmenta.lineasBase: nl: %3d ty: %3d, alturax1: %3d, base1: %3d\n",
                                      nl,     ty,      alturax1,      base1) ;
    */
    /*
    printf ("--------------- %4d\n", ty);
    {
    int i;
    for (i=0; i<ty; i++)
      printf(" %3d",pendientes[i]);
    printf("\n");
    }
    */
  }
  // alturax1 = base1 - 39;
  // printf ("altura-base: %4d\n",base1-alturax1);
  *base    = base1 ;
  *alturax = alturax1 ;
/*
    pintaRhn (vent, *base   , 0, vent->tx-1, 3);
    pintaRhn (vent, *alturax, 0, vent->tx-1, 2);
*/
}

void lineasBase2 (int *base, int *alturax, tvent vent)
{
  int hisH[MAXPIXV];
  int pendientes[MAXPIXV];
  int ty;
  int base1, alturax1;
  histoHor2 (hisH, vent) ;
  ty = vent->ty;
  aplicaV (hisH, pendientes, ty, 1, pend) ; 
  /*
  printf ("--------------- %4d\n", ty);
  {
  int i;
  for (i=0; i<ty; i++)
    printf(" %3d",pendientes[i]);
  printf("\n");
  }
  */
  base1    = posmaxv (pendientes, ty);
  alturax1 = posminv (pendientes, ty);
  if ( (alturax1 > base1) || ((base1 - alturax1) < ty/3) )
    {
    /*
    static int nl = 0;
    nl ++;
    printf("ocre.segmenta.lineasBase: nl: %3d ty: %3d, alturax1: %3d, base1: %3d\n",
                                      nl,     ty,      alturax1,      base1) ;
    */
    /*
    printf ("--------------- %4d\n", ty);
    {
    int i;
    for (i=0; i<ty; i++)
      printf(" %3d",pendientes[i]);
    printf("\n");
    }
    */
  }
  *base    = base1 ;
  *alturax = alturax1 ;
/*
    pintaRhn (vent, *base   , 0, vent->tx-1, 3);
    pintaRhn (vent, *alturax, 0, vent->tx-1, 2);
*/
}

//----------------------- capitular -----------------------

void segmentaSiCapitular (Boolean *hayCapitular, tvent *ventSc,
                          tvent *ventCap, tvent vent)
{
  int hisV[MAXPIXH];
  int hisH[MAXPIXV];
  int umbral;
  int porcNeg = 45;
  tdcaracHistoGr carHisGr;
  timagf imag3;
  // int nh;
  tvectder vectder;
  tvectder vectder2;
  lista cortes;
  lista cortes2;
  lista columCap;
  lista linCap;
  int ncol, nlin;
  tvent ven3;
  tvent venCol;
  tvent venCap0;
  tvent venCap01;
  tvent venCap;
  timagf imagSinCap;
  //   erosionar
  prepara (vent);
  carHisGr = carhisgrDeVentana (vent);
  umbral  = (carHisGr->xnegro  * porcNeg +
              carHisGr->xblanco * (100 - porcNeg) ) / 100;
  erosionadaImagenDeVentana (&imag3, vent, umbral, carHisGr->xblanco, 7);
  // presentaVentanayPara (ven3, "salCap01.pgm", 1);
  ven3 = imag3->ven0 ;
  //    columna
  histoVer (hisV, ven3);
  //presentaHistoVer (&nh, hisV, ven3, "salCap01.dat", "salCap01.gpt");
  vectderDeHisto (&vectder, hisV, ven3, ven3->tx, "P");
  // presentaHisVectder (&nh, hisV, vectder, "sal26h.dat", "sal26h.gpt");
  cortaLin (&cortes, vectder, ven3->tx);
  // imprimeSegmentos (cortes);
  ncol = longLista (cortes);
  if (ncol == 0) {
    *hayCapitular = FALSE;
    *ventSc = vent;
    return ;
    }
  if (ncol >= 2) {
    if (d_valori >= 10)
      printf ("ocre.segmentaSiCapitular, 2 o mas cols\n");
    // exit (0);
    }
  // describeVentana (ven3);
  ventanasDeCortes (&columCap, ven3, cortes, ventanaEnVentanaLargVer);
  //    printf ("paso por 1003\n");
  venCol = (tvent)(columCap->primero->aitem) ;
  // describeVentana (venCol);
  // escribeVentana (venCol, "salCap02.pgm");
  //    ventana
  histoHor (hisH, venCol);
  // presentaHistoHorH (&nh, hisH, venCol, "salCap02.dat", "salCap02.gpt");
  vectderDeHisto (&vectder2, hisH, venCol, venCol->ty, "P");
  // presentaHisVectder (&nh, hisH, vectder2, "salCap03.dat", "salCap03.gpt");
  cortaLin (&cortes2, vectder2, venCol->ty);
  // imprimeSegmentos (cortes2);
  nlin = longLista (cortes2);
  if (nlin == 0) {
    *hayCapitular = FALSE;
    *ventSc = vent;
    return ;
    }
  if (ncol >= 2) {
    if (d_valori >= 10)
      printf ("ocre.segmentaSiCapitular, 2 o mas lins\n");
    // exit (0);
    }
  ventanasDeCortes (&linCap, venCol, cortes2, ventanaEnVentanaLargHor);
  venCap0 = (tvent)(linCap->primero->aitem) ;
  // escribeVentana (venCap0, "salCap03.pgm");
  // describeVentana (venCap0);
  ventanaEnVentana (& venCap01, vent,
                    venCap0->dx, venCap0->dy, venCap0->tx, venCap0->ty);
  // escribeVentana (venCap0, "salCap04.pgm");
  // describeVentana (venCap01);
  //    ventana ajustada
  ajustadaVHext (&venCap, venCap01, vent->imaBase->ven0, umbral);
  if ((venCap->tx > vent->tx/3) ||        // muy grande
      (venCap->ty > vent->ty/3) ||
      (venCap->dx < 5 ) ||                // al borde
      (venCap->dy < 5 ) ||
      (vent->tx - venCap->dx - venCap->tx < 5 ) ||
      (vent->ty - venCap->dy - venCap->ty < 5 )  ) {
    *hayCapitular = FALSE;
    *ventSc = vent;
    return ;
    }
  if (venCap->ty < 15) {
    *hayCapitular = FALSE;
    *ventSc = vent;
    return ;
    }
  // escribeVentana (venCap, "salCap05.pgm");
  // describeVentana (venCap);
  copiaImagenDeVentana (&imagSinCap, vent);
  if ( ! cabeRectanguloEnVentana ( imagSinCap->ven0,
                         venCap->dx - vent->dx, venCap->dy - vent->dy,
                         venCap->tx, venCap->ty) ) {
    *hayCapitular = FALSE;
    *ventSc = vent;
    return ;
    }
  rectanguloGrisEnVentana (imagSinCap->ven0,
                         venCap->dx - vent->dx, venCap->dy - vent->dy,
                         venCap->tx, venCap->ty, carHisGr->xblanco);
  // presentaVentanayPara (imagSinCap->ven0, "salCap06.pgm", 1);
  // escribeVentana (imagSinCap->ven0, "salCap06.pgm");
  *hayCapitular = TRUE;
  *ventSc  = imagSinCap->ven0;
  *ventCap = venCap;
}

